<?php
function load_module_locale()
{
// Ensure that the main language array is loaded
	lmsg('');

	$locale = get_locale();
	$defaultLocale = 'en-US';

	if (!is_dir(PRODUCT_ROOT."/admin/plib/modules/".MODULE_NAME."/locales/$locale"))
		$locale = $defaultLocale;

	global $lmsg_arr;
	$lmsg_main = $lmsg_arr;

	if ($locale != $defaultLocale)
		include_once(PRODUCT_ROOT."/admin/plib/modules/".MODULE_NAME."/locales/$locale/messages_$locale.php");
	$lmsg_custom = $lmsg_arr;

	require_once(PRODUCT_ROOT."/admin/plib/modules/".MODULE_NAME."/locales/$defaultLocale/messages_$defaultLocale.php");

	$lmsg_arr = array_merge((array)$lmsg_main, (array)$lmsg_arr, (array)$lmsg_custom);
	unset($lmsg_custom);
	unset($lmsg_main);
	
	global $session;

	$specific_conhelp = $session->getParam('specific_conhelp');
	$reload = false;

	if (!isset($specific_conhelp["sbm__$defaultLocale"])) {
		$specific_conhelp["sbm__$defaultLocale"]
			= array('arr_name' => 'sbm_conhelp_arr',
					'conhelp_file' => "modules/".MODULE_NAME."/locales/$defaultLocale/conhelp_$defaultLocale.php");
		$reload = true;
	}

	if (!isset($specific_conhelp["sbm__$locale"])) {

		$specific_conhelp["sbm__$locale"]
			= array('arr_name' => 'sbm_conhelp_arr',
					'conhelp_file' => "modules/".MODULE_NAME."/locales/$locale/conhelp_$locale.php");
		$reload = true;
}

 	if ($reload)
		$session->putParam('specific_conhelp', $specific_conhelp);
	return $reload;
}
$sbm_reload_left_frame = load_module_locale();
?>
