<?
include_once("modules/pm.php");

function RA_show_resellers()
{
	include_once('class.PleskResellersList.php');
	global $server;
	$page = 0;
	$dom_list =new PleskResellersList($server['id']);
	$dom_list->resetError_();

	$res = $dom_list->getPageHeader();
	
	// fetch list
	$dom_list->fetchPleskResellersList();
	if ($dom_list->error())
		return false;

	$dom_list->applayFilter_();
	if ($dom_list->error())
		return false;

		$dom_list->applaySort_();
	if ($dom_list->error())
		return false;

	$dom_list->setPageSize($_SESSION['sbm_psa_resellers_page_size']);
	$page = ($dom_list->filter_ == '')? $_SESSION['sbm_psa_resellers_page_size']:0;
	$dom_list->setPage($page);
	$dom_list->applayPage_();	
	
	$res .= $dom_list->get_table();
	$res .= $dom_list->get_bottom();
	
	return $res;
}

function add_hosts($domain_id, $owner = "")
{
	global $server;
	require_once('class.DomainList.php');
	$domain = new DomainList($server['id']);
	$domain->fetchDomainList($domain_id);
	foreach ($domain->list_ as $subdomain)
	{
		if (add_sb_host($subdomain['name'])){
			$host = new RA_Hosts();
			$host->assign_resseller($subdomain['name'], $owner);
		}
	}
	
}



function resellers_allow_access($dom_list)
{
	include_once("class.sbmDomain.php");
	if (strpos($dom_list, ',')) $dom_list = substr($dom_list, 0, -1);
	$domain_list = split(',' , $dom_list);
	foreach ($domain_list as $domain_id) {
		if (get_reseller_id($domain_id)){
			continue;
		}
		
		$domain = new sbm_Domain($domain_id);
		$sites_limit = get_sites_limit($domain_id);
		
		if (sbm_add_reseller($domain->getHostname(), $domain->getFtpLogin(), $domain->getFtpPasswd(), $sites_limit))
		{
			if ($host = add_sb_host($domain->getIPAddress())){
				$host->assign_resseller($domain->getIPAddress(), $domain->getFtpLogin()."@".$domain->getHostname());
			}
//			add_hosts($domain->getID(), $domain->getFtpLogin()."@".$domain->getHostname(), $domain->getFtpPasswd());
			$url = '/modules/sbm2/index.php?sb_server='.$domain->sb_server['name'].'&ra_cmd=main&pswd';
			cb_clean($domain->getID(), $url);
			$prefix = (isset($_SERVER['HTTP_HOST'])) ? "https://".$_SERVER["HTTP_HOST"] : "https://".get_param('FullHostName').":8443";
			$url = $prefix."/modules/sbm2/index.php?sb_server=".$domain->sb_server['name'].'&ra_cmd=main&ftp_user='.$domain->getFtpLogin()."@".$domain->getHostname().'&ftp_pass='.$domain->getFtpPasswd();
			sbm_create_button($domain->getID(), $url);
			$query = 'REPLACE INTO `'.RA_TBL_RESELLERS.'` SET `domain_id` = \''.$domain->getID().'\', `sb_server_id` = \''.$domain->sb_server['id'].'\''.", `sb_login` = '".$domain->getFtpLogin()."@".$domain->getHostname()."';";
			db_query($query);
		}
	}
}

function resellers_deny_access($dom_list)
{
	global $server;

	if (strpos($dom_list, ',')) 
		$dom_list = substr($dom_list, 0, -1);
	$domain_list = split(',' , $dom_list);
	foreach ($domain_list as $domain_id) {
		if (!get_reseller_id($domain_id))
			continue;
		$url = '/modules/sbm2/index.php?sb_server='.$server['name'].'&ra_cmd=main&pswd';
		cb_clean($domain_id, $url);
		$host_str = get_domain_ipaddress($domain_id);
		$reseller_login = get_reseller_sb_login($domain_id);
		$dom_str .= $reseller_login.',';

		$host = new RA_Hosts();
		$host->deassign_resseller($host_str, $reseller_login);

	}
	if ($dom_str == "")
		return;
	
	sbm_delete_resellers(substr($dom_str, 0, -1));

	$dom_list = str_replace(",", "' OR domain_id ='", $dom_list);
	$query = 'DELETE FROM `'.RA_TBL_RESELLERS.'` WHERE `domain_id` = \''.$dom_list.'\' AND `sb_server_id`= \''.$server['id'].'\';';
	db_query($query);
}



function sbm_add_reseller ($sb_domain, $sb_ftp_user, $sb_passwd, $sites_limit = "-1")
{
	global $stat_msg;
	$curr_skin = 'default';
//	$lang = $session->getParam(SPN_LOCALE) ? str_replace('-', '_', $session->getParam(SPN_LOCALE)) : "en_US";
	$lang = "en_US";
	$reseller = new RA_Resellers();
	$par = &$reseller->data[NEW_ID];
	$par['DOMAIN'] = $sb_domain;
	$par['EMAIL'] = 'please@specify.email';
	$par['NAME'] = "PSAReseller";
	$par['LOGIN']	=	$sb_ftp_user."@".$sb_domain;
	$par['SKIN']	=	$curr_skin;
	$par['LANGUAGE'] = $lang;
	$par['PSWD'] = $sb_passwd;
	$par['PSWD_CONF'] = $sb_passwd;
	$par['HOSTS'] = $sb_domain;
	$par['LIMIT_SITES'] = $sites_limit;
	$par['LIMIT_HOSTS'] = 1;
	$reseller->add();

	if ($reseller->error()){
		$cmd = check_result($reseller->error());
		if ($cmd == 0 || $cmd == 1){
			$stat_msg .= lmsg('RA__msg_err_add_reseller')." '$sb_domain': ".$reseller->error['MESSAGE']." ";
			return false;
		}
	}
	return $reseller;
}


function sbm_delete_resellers ($sb_login)
{
	global $stat_msg;
	$reseller = new RA_Resellers();
	$reseller->delete($sb_login);
	if ($reseller->error()){
		$cmd = check_result($reseller->error());
		if ($cmd == 0 || $cmd == 1){
			$stat_msg .= lmsg('RA__msg_err_del_reseller')." '$sb_login': ".$reseller->error['MESSAGE']." ";
			return false;
		}
	}
	return $reseller;
}

function sbm_create_button($domain_id, $url)
{
	$img_path = PRODUCT_ROOT.'/admin/htdocs/modules/sbm2/images/icon.gif';
	//$cb_tool =PRODUCT_ROOT."/bin/custombutton.sh";
//	msg_exec("$cb_tool --create -owner \"$dom_name\" -place \"domain\" -text \"Remote Admin for SiteBuilder2\" -url \"$url\" -conhelp \"Click here to manage your SiteBuilder\" -file $img_path -internal \"true\"");
//	return msg_exec("$cb_tool --create -owner \"$dom_name\" -place \"navigation\" -text \"Remote Admin for SiteBuilder2\" -url \"$url\" -conhelp \"Click here to manage your SiteBuilder\" -file $img_path -internal \"true\"");
	foreach (array('domain', 'navigation') as $place){
		if (!class_exists('pm_CustomButton')) {
			require_once('class.CustomButton.php');
			$custom_button = objectMaker('CustomButton', 0);
		} else 
			$custom_button = objectMaker('pm_CustomButton',0);
		
		$custom_button->setConhelp('Click here to manage your SiteBuilder2');
		$custom_button->setText("Remote Admin for SiteBuilder2");
		$custom_button->setUrl($url);
		$custom_button->setLevel(IS_DOMAIN_OWNER);
		$custom_button->setLevelID($domain_id);
		$custom_button->setPlace($place);
		$custom_button->setFile($img_path);
		$custom_button->setInternalBit(true);
	
		$custom_button->update();
		if ($custom_button->error()){
			return false;
		}
	}
	return true;
}

include_once(PRODUCT_ROOT."/admin/plib/modules/sbm2/RA_domains.php");

?>