<?php

include_once('class.cList.php3');
#include_once('modules/pm.php');

class DomainList extends cList
{
	var  $dom_id_ = 0;
	var $sort_default_ = 'name';
	var $manage_domains;
	var $sb_server_id;

	function DomainList($sb_server='')
	{
		$this->cList();
		if ($this->error())
			return;

		$this->listHeader_ = lmsg('RA__hdr_domainPage');
		$this->removeTarget_ = 'removeDNS.php';
		$this->sb_server_id = $sb_server;
		$this->columns_ = array(
			1	=>	array('size' => 0, 'name' => 'domain_id', 'sort' => 'domain_id'),
			2	=>	array('size' => 0, 'name' => 'subdomain_id', 'sort' => 'subdomain_id'),
			3	=>	array('size' =>	20, 'name' => 'Domains', 'sort' => 'name'),
			4	=>	array('size' => 15, 'name' => 'Site_Alias', 'sort' => 'site_alias'),
			5	=>	array('size' => 20, 'name' => 'Client', 'sort' => 'client_cname'),
			6	=>	array('size' => 20, 'name' => 'Company', 'sort' => 'client_pname'),
			7	=>	array('size' => 5, 'name' => 'Status', 'sort'=> 'allowed'),
		);

		return;
	}
	
	
	function fetchSubDomainList($dom_id, $client, $id)
	{
		global $server;
		$query = "SELECT `subdomains`.`name`,`subdomains`.`displayName`, `subdomains`.`id`, `domains`.`name`,`domains`.`displayName`,
				`sys_users`.`login`, `domains`.`id` 
				FROM `subdomains` LEFT JOIN `sys_users` ON `subdomains`.`sys_user_id` = `sys_users`.`id` 
				LEFT JOIN `domains` ON `domains`.`id`=`subdomains`.`dom_id` 
				WHERE `subdomains`.`dom_id`='$dom_id';";
		$res = db_query($query);
		while (list($subdomain['name'],$subdomain['displayName'], $subdomain['id'], $subdomain['domain'], $subdomain['domain_displayName'], $subdomain['username'], $subdomain['domain_id']) = mysql_fetch_row($res)) {
			$subdomain['site_alias'] = str_replace(array('.', '@', '_', ':'), '-', $server['username']."-".$subdomain['name']."-".$subdomain['domain']."-site");
			$subdomain['allowed'] = check_site_id("0", $subdomain['id']);
			if (!$this->domain_in_list("0", $subdomain['id'])){
				$this->list_add_subdomain($id, $subdomain, $client);
				$id ++;
			}
		}
		mysql_free_result($res);
		return $id;
	}

	function list_add_subdomain($id, $subdomain, $client)
	{
		global $server;
		if (!isset($id))
			return;

		$this->list_[$id]= array(
		'domain_id' => 0,
		'subdomain_id' => $subdomain['id'],
		'name'=>$subdomain['name'].".".$subdomain['domain'],
		'display_name' => $subdomain['displayName'].".".$subdomain['domain_displayName'],
		'site_alias' =>	$subdomain['site_alias'], 
		'client_cname' =>$client['cname'], 
		'client_pname' =>$client['pname'], 
		'allowed' =>$subdomain['allowed'],
		'sbserver_id' =>$subdomain['sb_server_id'],
		);
	}
	
	function list_add_domain($id, $domain, $client)
	{
		global $server;
		if (!isset($id))
			return;

		$this->list_[$id] = array(
			'domain_id' => $domain['id'],
			'subdomain_id' => 0,
			'name'=>$domain['name'],
			'display_name' => $domain['display_name'],
			'site_alias' =>	$domain['site_alias'], 
			'client_cname' =>$client['cname'], 
			'client_pname' =>$client['pname'], 
			'allowed' =>$domain['allowed'],
			'sbserver_id' =>$domain['sb_server_id'],
			);
	}
	
	function domain_in_list($domain_id, $sub_id = "0")
	{
		if (!isset($domain_id))
			return false;
		foreach ($this->list_ as $list_domain){
			if ($list_domain['domain_id'] == $domain_id && $list_domain['subdomain_id'] == $sub_id){
				return true;
			}
		}
		return false;
	}
	
	function fetchDomainList($dom_id = "")
	{
		global $server;
		$this->list_ = array();
		$dom_user = ($dom_id != "") ? "AND `domains`.`id` = '".$dom_id."'" : "";
		$query = 'SELECT `domains`.`id`, `domains`.`name`, `domains`.`displayName`, `sys_users`.`login`, `clients`.`cname`, `clients`.`pname` FROM `domains` 
			LEFT JOIN `clients` ON `domains`.`cl_id` = `clients`.`id` 
			LEFT JOIN `hosting` ON `hosting`.`dom_id`=`domains`.`id` 
			LEFT JOIN `sys_users` on `sys_users`.`id`=`hosting`.`sys_user_id` 
			WHERE `domains`.`htype` = \'vrt_hst\' 
			'.$dom_user.';';
		$res = db_query($query);
		$id = 1;
		while (list($domain['id'], $domain['name'], $domain['display_name'], $domain['username'], $client['cname'], $client['pname']) = mysql_fetch_row($res)) {
			$domain['site_alias'] = str_replace(array('.', '@', ':', '_'), '-', $server['username'].'-'.$domain['name'].'-site');
			$domain['allowed'] = check_site_id($domain['id']);
			foreach($domain as $key => $var) $domain[$key] = htmlspecialchars($var);
            foreach($client as $key => $var) $client[$key] = htmlspecialchars($var);
			if (!$this->domain_in_list($domain['id'])){
				$this->list_add_domain($id, $domain, $client);
				$id++;
				$id = $this->fetchSubDomainList($domain['id'], $client, $id);
			}
		}
		mysql_free_result($res);
		
		if (!$this->lengthTotal_)
			$this->lengthTotal_ = $this->length();

		return true;

	}
			
		function getPageHeader()
	{
		global $stat_msg;
		
		$name='';
		$client_cname='';
		$client_pname='';
		$allowed='';
	    	$site_alias = '';
		
		if (!isset($_SESSION['page']))
			$_SESSION['page'] = 0;
	
		$_SESSION['page'] = (isset($_GET['page'])) ? $_GET['page'] : $_SESSION['page'];
		
		if (!isset($_SESSION['page_size']))
			$_SESSION['page_size'] = 10;
		
		if(isset($_GET['page_size'])){
			$_SESSION['page_size'] = $_GET['page_size'];
			$_SESSION['page'] = 0;
		}
		
		if (!isset($_SESSION['sbm_domains_filter']))
			$_SESSION['sbm_domains_filter'] = "";
	
		if (isset($_POST['sb_cc_search_button'])){
			if ($_POST['sb_cc_search_button'] == 1) 
				$_SESSION['sbm_domains_filter'] = $_POST['sys_search_login'];
			if ($_POST['sb_cc_search_button'] == 2)
				$_SESSION['sbm_domains_filter'] = '';
		}
	
		if (!isset($_SESSION['sort_dir']))
			$_SESSION['sort_dir'] = 'asc';
		
		if (isset($_GET['sort_dir']))
			$_SESSION['sort_dir'] = $_GET['sort_dir'];
		
		if (!isset($_SESSION['sorted_by']))
			$_SESSION['sorted_by'] = 'name';
		
		$sorted_text = $_SESSION['sort_dir'] == 'asc' ? 'Ascending' : 'Descending';
		$sorted_by = (isset($_GET['sort_by']) && $_GET['sort_by'] != '') ? $_GET['sort_by'] : $_SESSION['sorted_by'];
		$_SESSION['sorted_by'] = $sorted_by;
		$$sorted_by = ' SORTBY="true" DIR="'.$_SESSION['sort_dir'].'" SORTED-TEXT="Sort In '.$sorted_text.' Order" ';
		$stat_msg .= lmsg('RA__sort_by_'.$sorted_by).". ";
		
		$_SESSION['sort_dir'] = ($_SESSION['sort_dir'] == 'asc') ? 'desc' : 'asc';
		$res = '<ENTITYLIST NAME="domains_form" ACTION="/index.php?ra_cmd=domains">'; 
		$res.= '<LOCALE NAME="MSG_NOTHING_SELECTED_ITEMS" VALUE="No items selected"/>';
		$res.= '<REMARK>'.lmsg('RA__msg_access_allowed').', '.lmsg('RA__msg_access_denied').'</REMARK>';
		$res .= '<TOP-PANEL>
		<SEARCH-FIELD NAME="sys_search_login" CAPTION="'.lmsg('bt_search').': '.lmsg('RA__hdr_domain').'" VALUE="'.stripslashes($_SESSION['sbm_domains_filter']).'"/>';
		$res .= '<SEARCH-BUTTON CAPTION="'.lmsg('bt_search').'" ONCLICK="dc(1);document.domains_form.sb_cc_search_button.value=1;document.domains_form.submit();"/>';
		$res .= '<BUTTON NAME="admin_show" CAPTION="'.lmsg('bt_show_all').'" ONCLICK="dc(1);document.domains_form.sb_cc_search_button.value=2;document.domains_form.submit();"/>';
		$res .= '</TOP-PANEL>';
		$res .= '<HIDDEN ID="sb_cc_search_button" NAME="sb_cc_search_button" VALUE="1"/>';
		$res .='<HIDDEN ID="id_activate" NAME="id_activate" VALUE=""/>';
		$res .='<HIDDEN ID="id_activate_sub" NAME="id_activate_sub" VALUE=""/>';
		$res .='<HIDDEN ID="com" NAME="com" VALUE=""/>';
		$res .='<HEAD>';
		$res .='<HEAD-ITEM WIDTH="1" CAPTION="N" STYLE="text-align:center"/>';
		$res .='<HEAD-ITEM WIDTH="7" ALIGN="CENTER" STYLE="text-align:center">';
		$res .='<CHECK VALUE="" ONCLICK="doSelectForDel(this)"/>';
		$res .='</HEAD-ITEM>';
		$res .='<HEAD-ITEM WIDTH="1" '.$allowed.' CAPTION="'.lmsg('RA__hdr_access').'">';
		$res .='<ACTION>/index.php?ra_cmd=domains&amp;sort_by=allowed&amp;sort_dir='.$_SESSION['sort_dir'].'</ACTION>';
		$res .='</HEAD-ITEM>';
		$res .='<HEAD-ITEM WIDTH="5"'.$name.' CAPTION="'.lmsg('RA__hdr_domain').'">';
		$res .='<ACTION>/index.php?ra_cmd=domains&amp;sort_by=name&amp;sort_dir='.$_SESSION['sort_dir'].'</ACTION>';
		$res .='</HEAD-ITEM>';
		$res .='<HEAD-ITEM WIDTH="7"'.$client_pname.' CAPTION="'.lmsg('RA__hdr_client_name').'">';
		$res .='<ACTION>/index.php?ra_cmd=domains&amp;sort_by=client_pname&amp;sort_dir='.$_SESSION['sort_dir'].'</ACTION>';
		$res .='</HEAD-ITEM>';
		$res .='<HEAD-ITEM WIDTH="7"'.$client_cname.' CAPTION="'.lmsg('RA__hdr_client_company').'">';
		$res .='<ACTION>/index.php?ra_cmd=domains&amp;sort_by=client_cname&amp;sort_dir='.$_SESSION['sort_dir'].'</ACTION>';
		$res .='</HEAD-ITEM>';
		$res .='<HEAD-ITEM WIDTH="5"'.$site_alias.' CAPTION="'.lmsg('RA__Site_Alias').'">';
		$res .='<ACTION>/index.php?ra_cmd=domains&amp;sort_by=site_alias&amp;sort_dir='.$_SESSION['sort_dir'].'</ACTION>';
		$res .='</HEAD-ITEM>';
		$res .='</HEAD>';
		
		
		$sort_dir = ($_SESSION['sort_dir'] == 'desc') ? '' : '_reverse';
		$_SESSION['sort_dir'] = ($_SESSION['sort_dir'] == 'desc') ?'asc' : 'desc';
		
		$this->filter_ = $_SESSION['sbm_domains_filter'];
		$this->sort_ = $sorted_by.$sort_dir;
		return $res;
	}


	function get_table()
	{
		global $server;
		$res='';
		if ($this->length() == 0)
			return $res;
		$num = $this->getPage()*$this->getpageSize();
		
		for ($id = $this->listBegin(); false !== $id; $id = $this->listNext()) {
			$domain = $this->list_[$id];
			$num++;
			$checked = 'D';
			$cmd_value=1001;
			if ($domain['allowed']){
				$checked = 'A';
				$cmd_value=1002;
				}
			$res.= '<ENTITY ENABLED="true">';
			$res.= '<ENTITY-ITEM ALIGN="CENTER" CAPTION="'.$num.'"/>';
			$res.= '<ENTITY-ITEM ALIGN="CENTER">';
			$res.= '<CHECK VALUE="';
			$res.= ($domain['domain_id'] != 0)?$domain['domain_id'].'" NAME="sb_domain_id[]"/>':$domain['subdomain_id'].'" NAME="sb_subdomain_id[]"/>';
			$res.= '</ENTITY-ITEM>';
			$res.= '<ENTITY-ITEM ALIGN="CENTER" CAPTION="'.$checked.'">';
			$res.= '<BUTTON CAPTION="'.$checked.'" ONCLICK="dc(1);document.forms[0].com.value='.$cmd_value.';';
			$res.= ($domain['domain_id'] != 0)?'document.forms[0].id_activate.value='.$domain['domain_id'].';':'document.forms[0].id_activate_sub.value='.$domain['subdomain_id'].';';
			$res.= 'document.forms[0].submit();"/>';
			$res.= '</ENTITY-ITEM>';
			$res.= '<ENTITY-ITEM ALIGN="LEFT" CAPTION="'.htmlspecialchars($domain['display_name']).'"/>';
			$res.= '<ENTITY-ITEM ALIGN="LEFT" CAPTION="'.htmlspecialchars($domain['client_pname']).'"/>';
			$res.= '<ENTITY-ITEM CAPTION="'.htmlspecialchars($domain['client_cname']).'">';
			$res.= '</ENTITY-ITEM>';
			$res.= '<ENTITY-ITEM ALIGN="LEFT" CAPTION="'.htmlspecialchars($domain['site_alias']).'"/>';
			$res.= '</ENTITY>';
		}
		if ($res)
			return $res;
		else
			return false;
	}
	
	function get_bottom()
	{
		static $ret;
		global $stat_msg;
		if (isset($ret))
			return $ret;
		$ret ='';
		
		$ret .= '<BOTTOM-PANEL>';
		$ret .= '<BUTTON NAME="bt_allow_access" CAPTION="'.lmsg('RA__btn_allow_access').'" ONCLICK="if(doActivateDomains(true)){dc(1);document.forms[0].com.value=1001;document.forms[0].submit();}"/>';
		$ret .= '<BUTTON NAME="bt_deny_access" CAPTION="'.lmsg('RA__btn_deny_access').'" ONCLICK="if(doActivateDomains(false)){dc(1);document.forms[0].com.value=1002;document.forms[0].submit();}"/>';
		$ret .= $this->getPaging();
		$ret .= '</BOTTOM-PANEL>';
		$ret.='</ENTITYLIST>';
		//$ret .= '<STATUS MESSAGE="'.$stat_msg.'"></STATUS></PAGE>';
		return $ret;
	}
	
	
	function getPaging()
	{
		static $ret;
		if (isset($ret))
			return $ret;

		$ret ='';

		$length = $this->getFilter() !== '' ? $this->lengthFilter() : $this->lengthTotal();
		$last = ceil($length / $this->getPageSize()) -1;

		if (0 >= $this->lengthTotal())
			return  $this->_displayEmptyMessage() . $ret.$this->lengthTotal().$this->length();
		if (($this->getFilter() !== '') && (0 >= $this->lengthFilter()))
			return lmsg('clist__info_filter', $this->listHeader_, 0, 0, 0, 0) . $ret;

		//$ret .= '<table width="100%"><tr><td>';
		$ret .= '<PAGE-STRIP>';
		// display info
		
		$ret .= '<PAGE-SIZE>'.lmsg('clist__page_size').'</PAGE-SIZE>';
                
		foreach (array(5,10,15) AS $psize) {
                        $ret .= '<PAGE-S ';
			$ret .=$this->getPageSize() == $psize ? '' : ' URL="/index.php?page_size='.$psize.'" ONCLICK="dc();"';
			$ret .= $this->getPageSize() ==$psize ? ' CURRENT="true" ' : '';	
			$ret .=">".$psize."</PAGE-S>";
                }

		$msg = 'clist__info'
			. ($length > $this->length() ? '_paging' : '')
			. ('' !== $this->getFilter() ? '_filter' : '');

		
		$ret .= '<BRS>'.lmsg($msg,
					$this->listHeader_,
					$this->getPage() * $this->getPageSize() + 1,
					$this->getPage() * $this->getPageSize() + $this->length(),
					$this->lengthTotal(),
					$this->lengthFilter()
				).'</BRS>';

		//$ret .= '</td><td align="center">';
		
		//eval left/rignt deltas
		$p_pd = $this->getPage() - $this->pagingSize_ < 0 ? $this->getPage() - $this->pagingSize_ : 0;
		$p_nd = $this->getPage() + $this->pagingSize_ > $last ? $last - ($this->getPage() + $this->pagingSize_) : 0;

		//eval display pages
		$p_min = $this->getPage() - $this->pagingSize_ + $p_pd + $p_nd < 0 ? 0 : $this->getPage() - $this->pagingSize_ + $p_pd + $p_nd;
		$p_max = $this->getPage() + $this->pagingSize_ - $p_pd - $p_nd > $last ? $last : $this->getPage() + $this->pagingSize_ - $p_pd - $p_nd;

                //$ret .= lmsg('clist__page_size') . ':';

		for ($p = $p_min; $p <= $p_max; $p++) {
			$ret .='<PAGE';
			$ret .=$p == $this->page_ ? '' : ' URL="/index.php?page='.safetyhtml($p).'" ';
			$ret .= $p == $this->page_ ? ' CURRENT="true" ' : '';
			$ret .= '>';
			$ret .= safetyhtml($p +1);
			$ret .='</PAGE>';
		}

		// paging control
		$ret .='<PREV-PAGE-SET />';
		$ret .='<PREV-PAGE />';
		
		$ret .='<NEXT-PAGE-SET />';
		$ret .='<NEXT-PAGE />';
		$ret .= '<FIRST-PAGE CAPTION="'.lmsg('clist__first').'" ';
		$ret .= ($this->page_ == 0) ? '':'URL="/index.php?page=0" ';
		$ret .= '/>';
		$ret .= '<LAST-PAGE CAPTION="'.lmsg('clist__last').'"';
		$ret .=($this->page_ == $last) ? '':' URL="/index.php?page='.$last.'" ';
		$ret .= '/>';
		$ret .= '</PAGE-STRIP>';
		
		//// page size control
		
		return $ret;
	}

	
		
	function getRemoveSelectedButton()
	{
		return cList::getRemoveSelectedButton();
	}
}

function check_site_id($domain_id="", $subdomain_id="")
{
    	$domain_id = ($domain_id == '') ? 0 : $domain_id;
    	$subdomain_id = ($subdomain_id == '') ? 0 : $subdomain_id; 

		global $server;
        $query = "SELECT `site_identity` FROM `".RA_TBL_DOMAINS."` WHERE `sb_server_id` ='".$server['id']."' AND `domain_id` ='".$domain_id."' AND `subdom_id` = '".$subdomain_id."' AND `site_owner` = '".$server['username']."';";
        $res = db_query($query);
        if (list($site_id) = mysql_fetch_row($res)){
              return $site_id;
        }
        return false;
}

?>
