<?php
include_once('class.errHandler.php');
include_once('messages.php');
include_once('constants.php3');
require_once('common_func.php3');
include_once('class.Session.php');
include_once('key/Key.php');

// detect VE before db_connect();
require_once('api-common/class.cu.php');
cu::initCLI();

$psa_is_configured = get_param('psa_configured');
if (!$psa_is_configured || ($psa_is_configured != 'true')) {
        cu::print_stderr('Plesk is not configured. You should go to the control panel for postinstall server configuration.');
        cu::cuExit(1);
}

// change current (root) sbm login 
function sbm_set_sb_login($server)
{
    if (!isset($server['name']) || $server['name'] == ''){
    	return false;
    }
	        
    $url = parse_url($server['name']);
    $server['ip_address'] = gethostbyname($url['host']);
		        
    $server['id'] = sbm_get_param('current_sb_server');

    if(!$server['id'])
    {
	$query = "SELECT id, sbserver_name from `".RA_TBL_SBSERVERS."` where sbserver_name='".$server['name']."';";
	if (false === ($db_res = mysql_query($query))) {
	    psaerror('Unable to query: '.db_error());
	    return false;
	}
    
	if(mysql_num_rows($db_res)>0 && $row = mysql_fetch_array($db_res, MYSQL_ASSOC)) {
	    $server['id'] = $row['id'];
	}
	else
	{
	    $cmd = "INSERT INTO ";
		        
    	    $query = $cmd."`".RA_TBL_SBSERVERS."` (sbserver_name, sbserver_ipaddress, sbserver_username, sbserver_password) VALUES('".$server['name']."', '".$server['ip_address']."', '".$server['username']."', '".$server['password']."');";
	    if (false === ($db_res = mysql_query($query))) {
		psaerror('Unable to query: '.db_error());
		return false;
	    }

	    $server['id'] = mysql_insert_id();
	}
	
	$query = "UPDATE `".RA_TBL_CONFIG."` SET param_value='".$server['id']."' where param_name = 'current_sb_server';";
	if (false === ($db_res = mysql_query($query))) {
	    psaerror('Unable to query: '.db_error());
	    return false;
	}
    }

    $cmd = "UPDATE ";
    $wh = " WHERE `id` = '".$server['id']."'";
		        
    $query = $cmd."`".RA_TBL_SBSERVERS."` SET `sbserver_name` = '".$server['name']."', `sbserver_ipaddress` = '".$server['ip_address']."', `sbserver_username` = '".$server['username']."', `sbserver_password` = '".$server['password']."'".$wh.";";
    if (false === ($db_res = mysql_query($query))) {
        psaerror('Unable to query: '.db_error());
        return false;
    }
    return true;
    
}
				
class sbm_register extends cu
{
		public	$allowed_commands = array(

		array(	CU_OPT_LONG		=> 'add',
				CU_OPT_SHORT	=> 'a',
				CU_OPT_PARAM	=> false,
				CU_OPT_DESC		=> 'Create reseller login in Sitebuilder (use Plesk Admin data).  Use  -server -user -password parameters for connection'),

		array (	CU_OPT_LONG		=> 'help',
				CU_OPT_SHORT	=> 'h',
				CU_OPT_PARAM	=> false,
				CU_OPT_DESC		=> 'Help page'),

	);

	public $allowed_options = array(

		array(	CU_OPT_LONG			=> 'server',
				CU_OPT_PARAM		=> true,
				CU_OPT_USAGE		=> '<server-name>',
				CU_OPT_DESC			=> 'Sitebuilder server name',
				CU_OPT_REGEX_ALLOW	=> CU_REGEX_ALLOW_DOMAIN
		),

		array(	CU_OPT_LONG			=> 'ip',
				CU_OPT_PARAM		=> true,
				CU_OPT_USAGE		=> '<Ip-Address>',
				CU_OPT_DESC		=> 'Ip-address of Sitebuilder server (optional)',
				CU_OPT_REGEX_ALLOW	=> CU_REGEX_ALLOW_IP
		),

		array(	CU_OPT_LONG			=> 'user',
				CU_OPT_PARAM		=> true,
				CU_OPT_USAGE		=> '<user-name>',
				CU_OPT_DESC			=> 'Sitebuilder root login',
				CU_OPT_REGEX_ALLOW	=> CU_REGEX_ALLOW_LOGIN
		),

		array(	CU_OPT_LONG			=> 'password',
				CU_OPT_PARAM		=> true,
				CU_OPT_USAGE		=> '<password>',
				CU_OPT_DESC			=> 'Sitebuilder root password',
//				CU_OPT_REGEX_ALLOW	=> CU_REGEX_ALLOW_DOMAIN
		),

		array(	CU_OPT_LONG			=> 'reseller_hosts_limit',
				CU_OPT_PARAM		=> true,
				CU_OPT_USAGE		=> '<hosts_limit>',
				CU_OPT_DESC		=> 'Limit of reseller available hosts number (optional - if unset, then hosts number is unlimited)',
				CU_OPT_REGEX_ALLOW	=> CU_REGEX_ALLOW_LIMIT
		),

		array(	CU_OPT_LONG			=> 'reseller_sites_limit',
				CU_OPT_PARAM		=> true,
				CU_OPT_USAGE		=> '<sites_limit>',
				CU_OPT_DESC		=> 'Limit of reseller regular sites number (optional - if unset, then regular sites number is unlimited)',
				CU_OPT_REGEX_ALLOW	=> CU_REGEX_ALLOW_LIMIT
		),


	);

	function execute()
	{
		$cmds = parent::getCommand();
		if ($this->error() || is_null($cmds))
			return false;

		$keys = array_keys($cmds);
		$cmd = array_shift($keys);

		switch ($cmd) {

			case 'help':
				$this->printHelp();
				break;

			case 'man':
				$this->_printMan();
				break;

			case 'add':
				global $opts;
				/* require options -server -user -password */
				$this->setRequiredOptions(array('server', 'user', 'password'));
				$opts = parent::getOptions();
				if ($this->error())
					return false;
				
				// set sb server to connect
				global $rserver;
				global $server;
				global $GLOBALS;
				$GLOBALS['server'] = $server;
				$server['name'] = "http://" . $opts['server'] . "/remote_admin/";
				$server['ip_address'] = "0.0.0.0";
				$server['username'] = $opts['user'];
				$server['password'] = $opts['password'];				
				
				// add reseller in SB for this SBM
				if ($this->add_reseller()){
					cu::print_stdout('Reseller has been successfully added' . "\n");
					$rserver['name'] = $server['name'];

					// change root login parameters in SBM database
					if(sbm_set_sb_login($rserver)) {
					    cu::print_stdout('Login has been updated in sbm' . "\n");
					}
					else
					{
					    $this->setError_('Error occurs when updating Login in SBM');
					}						
				}
				break;

			
			default:
				return $this->setError_('Unknown command: "' . $cmd . '"');
		}

		return true;
	}
	
	
	/* 
	create reseller for this SBM in SB 
	login    = "<Company name from PSA config>_<Host name from PSA config>"
	password = <PSA admin password>
	email    = <PSA admin email>
	 */
	function add_reseller()
	{
		global $rserver, $opts;
		global $stat_msg;
		$curr_skin = 'default';
	//	$lang = $session->getParam(SPN_LOCALE) ? str_replace('-', '_', $session->getParam(SPN_LOCALE)) : "en_US";
		$lang = "en_US";
		$reseller = new RA_Resellers();
		$par = &$reseller->data[NEW_ID];
		$par['DOMAIN'] = get_param('FullHostName');
		$par['EMAIL'] = get_param('admin_email');
		$par['NAME'] = 'PSAAdmin';
		$par['LOGIN']	=	get_param('FullHostName'); $rserver['username'] = $par['LOGIN'];
		$par['SKIN']	=	$curr_skin;
		$par['LANGUAGE'] = $lang;
		$par['PSWD'] = get_admin_password(); $rserver['password'] = $par['PSWD'];
		$par['PSWD_CONF'] = get_admin_password();
	        if($opts['reseller_sites_limit']) $par['LIMIT_SITES'] = $opts['reseller_sites_limit'];
	        if($opts['reseller_hosts_limit']) $par['LIMIT_HOSTS'] = $opts['reseller_hosts_limit'];
		$reseller->add();
		if ($reseller->iserror()){
			$this->setError_($reseller->error['MESSAGE']);
			$stat_msg .= sprintf("%s %s: %s ",lmsg('RA__msg_err_add_reseller'),$par['DOMAIN'],$reseller->error['MESSAGE']);
			return false;
		}
		return $reseller;
		
	}
}


define ('MODULE_NAME',"sbm2");

include_once("modules/sbm2/common.php");
require_once('modules/sbm2/ra_api.php');
require_once('modules/sbm2/RA_domains.php');
require_once('modules/sbm2/config.php');


$sr = new sbm_register();
if ($sr->error()) {
	cu::print_stderr($sr->getErrorMsg());
	cu::cuExit(1);
}

$sr->execute();
if ($sr->error()) {
    cu::print_stderr($sr->getErrorMsg());
    cu::cuExit(1);
}

cu::cuExit(0);

?>