<?
//print_r($_POST);
define ('MODULE_NAME', 'sbm2');
define ('PLIB_PATH', PRODUCT_ROOT."/admin/plib/modules/".MODULE_NAME);

include_once(PLIB_PATH . "/config.php");
include_once(PLIB_PATH . "/ra_api.php");
include_once(PLIB_PATH . "/common.php");
include_once("curl_send.php");
//print_r($_GET);
//print_r($_POST);
//exit;
session_start();
$server = $_SESSION['server'];

function treatmentPost(&$post, $key, $val)
{
		if($key == 'do' || substr($post, 0, 1) == '_' || (is_array($filter) && !in_array($key, $filter))) 
		{
		    unset($post[$key]);
		}
		elseif(!is_array($val))
		{
			$post[$key] = htmlspecialchars(sbm_strip_slashes($val));
		}
		else
		{
			foreach ($val as $subkey => $subval)
			{
				treatmentPost($val, $subkey, &$subval);
				$post[$key] = $val;
			}
		}
}

function processPost($session = null, $post = null, $field = null, $filter = null)
{

	foreach ($post as $key => $val)
	{
		treatmentPost($post, $key, $val);
	}
	if(!is_null($field))
	{
		$session[$field] = array_merge((array)$session[$field], (array)$post);
	}
	else
	{	
		$session = array_merge((array)$session, (array)$post);
	}
	
	return $session;
}

function removefromList($data, $key, $post)
{
	$ids = explode(',', $post);
	foreach ($ids as $id)
	{
		if(array_key_exists($id, $data))
		{
			unset($data[$id]);
		}
	}
	return $data;
}

function addtoList($data, $key, $post)
{
	$ids = explode(',', $post);
	foreach ($ids as $id)
	{
		if(!array_key_exists($id, $data))
		{
			$data[$id] = array($key => $id);
		}
	}
	return $data;
}

// calculate ra_cmd of accordinaly lists
function url_of_list($ra_cmd)
{
	if($ra_cmd == RANGE)
		return HOSTS;
	else
		return $ra_cmd . 's';
}

// sorting
if(isset($_GET['to_sorl']) && isset($_GET['to_sort']))
{
	$sord = $_SESSION['sort'][$_GET['to_sorl']][$_GET['to_sort']];
	if(key_exists($_GET['to_sort'], $_SESSION['sort'][$_GET['to_sorl']])) 
	{
		unset($_SESSION['sort'][$_GET['to_sorl']][$_GET['to_sort']]);
	}

	switch ($sord)
	{
		case ASC :
			$sord = DESC;
		break;
		//
		case DESC :
			$sord = ASC;
		break;
		//
		default:
			$sord = ASC;
	}

	$_SESSION['sort'][$_GET[to_sorl]] = array_merge(array($_GET['to_sort'] => $sord),(array)$_SESSION['sort'][$_GET['to_sorl']]);
	redirect($redirect_url);
}
elseif(isset($_POST['to_search']))
{
	if($_POST['to_search'] == '') unset($_SESSION['filter'][$_GET['to_filter_list']]);
	else $_SESSION['filter'][$_GET['to_filter_list']] = $_POST['to_search'];
	$_SESSION['paging'][$_GET['to_filter_list']]['page'] = 0;
	redirect($redirect_url);	
}
elseif(isset($_GET['to_page']))
{
	$_SESSION['paging'][$_GET['to_page_list']]['page'] = $_GET['to_page'];
	redirect($redirect_url);	
}
elseif(isset($_GET['to_page_size']))
{
	$_SESSION['paging'][$_GET['to_page_list']]['page_size'] = $_GET['to_page_size'];
	redirect($redirect_url);	
}


if(!isset($_GET['id'])) $id = NEW_ID;
else $id = $_GET['id'];

switch ($_GET['ra_cmd'])
{
	case HOSTS:	
			{	
			$list = new RA_Hosts();
			$list->process();
			break;
			}

	case SKINS:
			{	
			$list = new RA_Skins();
			$list->process();
			break;
			}

	case LANGUAGES:	
			{	
			$list = new RA_Langs();
			$list->process();
			break;
			}

	case TEMPLATES:	
			{
			$list = new RA_Templates();
			$list->process();
			break;
			}

	case MODULES:	
			{
			$list = new RA_Modules();
			$list->process();
			break;
			}
			
	case RESELLERS: 
			{	
			$list = new RA_Resellers();
			$list->process();
			break;
			}
		
	case SITES:	
			{	
			$list = new RA_Sites();
			$list->process();
			break;
			}

	case PLANS :
			{
			$list = new RA_Plans();
			$list->process();
			break;
			}
	
// ------------------------------------------------------------------------------------------	
	
	case SITE :
		if(isset($_SESSION['ra_sites'])) $list = unserialize($_SESSION['ra_sites']);
		else $list = new RA_Sites();

		if(!isset($_GET[TAB])) $_GET[TAB] = GENERAL;
		switch ($_GET[TAB])
		{
			case GENERAL :
				if($_POST['PLAN'] != $list->site[$id]['PLAN'])
				{
					$plans = new RA_Plans();
					if(isset($_POST['PLAN']))
					{
						$plans->get_details($_POST['PLAN']);
						$_POST['SITE_PLAN'] = $plans->parse_details();
					}
				}
				$list->site[$id] = processPost($list->site[$id], $_POST);
			break;

			case PUBLISH :
				$list->site[$id] = processPost($list->site[$id], $_POST);
			break;

			case EMAIL :
				$list->site[$id] = processPost($list->site[$id], $_POST);
			break;

			case PLAN :
				$post = $_POST;
				if(!isset($_GET[SUBTAB]) || $_GET[SUBTAB] == GENERAL)
				{
					$list->site[$id]['SITE_PLAN'] = processPost($list->site[$id]['SITE_PLAN'], $_POST);
				}
				elseif($post['id_activate']) 
				{
					switch ($_GET[SUBTAB])
					{
						case HOSTS :
							$listname = 'HOSTS';
							$listid = 'HOST_NAME';
						break;

						case MODULES :
							$listname = 'MODULES';
							$listid = 'NAME';
						break;							

						case TEMPLATES :
							$listname = 'TEMPLATES';
							$listid = 'ID';
						break;							
					}
					
					$ids = substr($post['id_activate'], 0, -1); 
					switch ($post['com'])
					{
						// remove from list 
						case 1008 :
							$list->site[$id]['SITE_PLAN'][$listname] = removefromList($list->site[$id]['SITE_PLAN'][$listname], $listid, $ids);
						break;
						
						// add to list
						case 1009 :
							$list->site[$id]['SITE_PLAN'][$listname] = addtoList($list->site[$id]['SITE_PLAN'][$listname], $listid, $ids);
						break;
					}
				}

				$list->site[$id] = processPost($list->site[$id], $_POST);
			break;
		$list->site[$id] = processPost($list->site[$id], $_POST);
		}
		if($_GET['type'] == 'TRIAL') $list->site[$id]['TYPE'] = 'TRIAL';
		elseif($_GET['type'] == 'REGULAR') $list->site[$id]['TYPE'] = 'REGULAR';
			
	break;
	
	// plan
	case PLAN :
		$post = $_POST;

		if(isset($_SESSION['ra_plans'])) 
		{
		    $list = unserialize($_SESSION['ra_plans']);
		}
		else 
		{
		    $list = new RA_plans();
		}

		if(!isset($_GET[TAB])) $_GET[TAB] = GENERAL;
		if($_GET[TAB] == GENERAL)
		{
			$list->plan[$id] = processPost($list->plan[$id], $_POST);
		}
		elseif($post['id_activate'])
		{
			switch ($_GET[TAB])
			{
				case HOSTS :
					$listname = 'HOSTS';
					$listid = 'HOST_NAME';
				break;

				case MODULES :
					$listname = 'MODULES';
					$listid = 'NAME';
				break;							

				case TEMPLATES :
					$listname = 'TEMPLATES';
					$listid = 'ID';
				break;							
			}
			
			$ids = substr($post['id_activate'], 0, -1); 
			switch ($post['com'])
			{
				// remove from list 
				case 1008 :
					$list->plan[$id][$listname] = removefromList($list->plan[$id][$listname], $listid, $ids);
				break;
				
				// add to list
				case 1009 :
					$list->plan[$id][$listname] = addtoList($list->plan[$id][$listname], $listid, $ids);
				break;
			}
		}

		$list->plan[$id] = processPost($list->plan[$id], $_POST);
	break;

	// reseller
	case RESELLER :
		$post = $_POST;
		
		if(isset($_SESSION['ra_resellers'])) $list = unserialize($_SESSION['ra_resellers']);
		else $list = new RA_Resellers();
		
		if(!isset($_GET[TAB])) $_GET[TAB] = GENERAL;		
		if($_GET[TAB] == GENERAL)
		{
			$list->data[$id] = processPost($list->data[$id], $post);
		}
		elseif($post['id_activate'])
		{
			switch ($_GET[TAB])
			{
				case HOSTS :
					$listname = 'HOSTS';
					$listid = 'HOST_NAME';
				break;

				case SITES :
					$listname = 'SITES';
					$listid = 'SITE_ALIAS';
				break;							

				case PLANS :
					$listname = 'PLANS';
					$listid = 'NAME';
				break;							
			}
			
			$ids = substr($post['id_activate'], 0, -1); 
			switch ($post['com'])
			{
				// remove from list 
				case 1008 :
					$list->data[$id][$listname] = removefromList($list->data[$id][$listname], $listid, $ids);
				break;
				
				// add to list
				case 1009 :
					$list->data[$id][$listname] = addtoList($list->data[$id][$listname], $listid, $ids);
				break;
			}
		}

		$list->data[$id] = processPost($list->data[$id], $_POST);
	break;
	
	case HOST :
		$post = $_POST;

		if(isset($_SESSION['ra_hosts'])) $list = unserialize($_SESSION['ra_hosts']);
		else $list = new RA_hosts();

		if(!isset($_GET[TAB])) $_GET[TAB] = GENERAL;		
		if($_GET[TAB] == GENERAL || !isset($_GET[TAB]))
		{
			$list->data[$id] = processPost($list->data[$id], $post);
		}
		elseif($post['id_activate'] && $_GET[TAB] == RESELLERS)
		{
			$ids = substr($post['id_activate'], 0, -1); echo $post['com'];
			switch ($post['com'])
			{
				// remove from list 
				case 1008 :
					$list->data[$id]['RESELLER_LIST'] = removefromList($list->data[$id]['RESELLER_LIST'], 'LOGIN', $ids);
				break;
				
				// add to list
				case 1009 :
					$list->data[$id]['RESELLER_LIST'] = addtoList($list->data[$id]['RESELLER_LIST'], 'LOGIN', $ids);
				break;
			}
		}
		$list->data[$id] = processPost($list->data[$id], $_POST);
	break;	
	
	case RANGE :
		$post = $_POST;
		
		if(isset($_SESSION['ra_hosts'])) $list = unserialize($_SESSION['ra_hosts']);
		else $list = new RA_hosts();

		if(!isset($_GET[TAB])) $_GET[TAB] = GENERAL;		
		if($_GET[TAB] == GENERAL || !isset($_GET[TAB]))
		{
			$list->data[$id] = processPost($list->data[$id], $post);
		}
		elseif($post['id_activate'] && $_GET[TAB] == RESELLERS)
		{
			$ids = substr($post['id_activate'], 0, -1); echo $post['com'];
			switch ($post['com'])
			{
				// remove from list 
				case 1008 :
					$list->data[$id]['RESELLER_LIST'] = removefromList($list->data[$id]['RESELLER_LIST'], 'LOGIN', $ids);
				break;
				
				// add to list
				case 1009 :
					$list->data[$id]['RESELLER_LIST'] = addtoList($list->data[$id]['RESELLER_LIST'], 'LOGIN', $ids);
				break;
			}
		}
		$list->data[$id] = processPost($list->data[$id], $_POST);

	break;	
}

if(isset($_GET['to_tab']))
{
	if(isset($_SESSION[lowcase_get_class($list)])) $list->serialize();
	$redirect_url = 'index.php?ra_cmd='.$_GET['ra_cmd'].'&id='.$id.'&'.TAB.'='.$_GET['to_tab'];
}
elseif(isset($_GET['to_subtab']))
{
	if(isset($_SESSION[lowcase_get_class($list)])) $list->serialize();
	$redirect_url = 'index.php?ra_cmd='.$_GET['ra_cmd'].'&id='.$id.'&'.TAB.'='.$_GET[TAB].'&'.SUBTAB.'='.$_GET['to_subtab'];
}
elseif($_POST['todo'] == SAVE)
{
	if(isset($id) && $id != NEW_ID)
	{
		$list->update($id);
	}
	else 
	{
		$list->add();
	}
	if(!$list->isError()) 
	{
		unset($_SESSION[lowcase_get_class($list)]);
		$redirect_url = 'index.php?ra_cmd='.url_of_list($_GET['ra_cmd']);
	}
}
elseif($_POST['todo'] == CANCEL)
{
	unset($_SESSION[lowcase_get_class($list)]);
	$redirect_url = 'index.php?ra_cmd='.url_of_list($_GET['ra_cmd']);
}

if(!isset($redirect_url))
{
	$list->serialize();			
	$redirect_url = 'index.php?ra_cmd='.$_GET['ra_cmd'].'&';
	/* everything will have been done in redirect procedure
	if(isset($id)) $redirect_url .= 'id='.$id.'&';
	if(isset($_GET[TAB])) $redirect_url .= TAB.'='.$_GET[TAB].'&';
	if(isset($_GET[SUBTAB])) $redirect_url .= SUBTAB.'='.$_GET[SUBTAB].'&';
	*/
}
redirect($redirect_url);

?>
