<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">


<!--


-->
<xsl:template name="TOP-AREA">
 <table cellpadding="0" cellspacing="0" height="52" width="775" border="0" background="{$baseURL}/images/header_bg.gif" >
  <tr>
<!--
   <td><img src="{$baseURL}/images/def_sb_logo.gif" height="52" border="0"/></td>
-->
   <td valign="top" align="center" width='130'><img src="{$baseURL}/images/{$systemLOGO}" border="0">
    <xsl:if test="$heightLOGO!=''"><xsl:attribute name="height"><xsl:value-of select="$heightLOGO"/></xsl:attribute></xsl:if>
    <xsl:if test="$widthLOGO!=''"><xsl:attribute name="width"><xsl:value-of select="$widthLOGO"/></xsl:attribute></xsl:if>
   </img>
   </td>
   <td>
    <table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%" >
     <tr>
      <td align="right" valign="top">   
       <xsl:apply-templates select="/*/HEADER/TOOLBAR"/>
      </td>
     </tr> 
     <tr>
      <td align="right" valign="bottom">   
       <xsl:apply-templates select="/*/HEADER/TOP-MENU"/>
      </td>
     </tr>
    </table>
   </td>
  </tr>
 </table>
 <table cellpadding="0" cellspacing="0" height="27" width="775" border="0" background="{$baseURL}/images/top_border.gif">
  <tr>
   <td height="24" width="220">
    <table width="100%" cellspacing="0" cellpadding="0" border="0">
    <tr>
     <td class="SB_Style_short_login_text">
      <xsl:choose>
       <xsl:when test="/*/HEADER/TOP-MENU/TOP-MENU-STEP[MODE='overview' and SELECTED='TRUE'] or (/*/HEADER/TOP-MENU/TOP-MENU-STEP[MODE='genconf'] or /*/HEADER/TOP-MENU/TOP-MENU-STEP[MODE='users'] or /*/HEADER/TOP-MENU/TOP-MENU-STEP[MODE='update'])">
        <xsl:call-template name="LOGGED-USER-TEXT"/>
       </xsl:when>
       <xsl:otherwise>
        <xsl:variable name="previewButton" select="/*/HEADER/TOP-MENU/TOP-MENU-STEP[MODE='preview']"/>
        <xsl:if test="$previewButton">
        
        <xsl:choose>
           <xsl:when test="$browser='MOZILLA'">
            <xsl:choose>
         <xsl:when test="$previewButton/ENABLED='TRUE'">
          <table border="0" cellpadding="0" cellspacing="0" style="margin-left: 2px;">
          <xsl:attribute name="class">SB_Style_tablebutton</xsl:attribute>
          <tr>
           <td><img  border="0" src="{$baseURL}/images/pws_left.gif"/></td>
           <td class="SB_Style_pwsbuttontext" background="{$baseURL}/images/pws_bg.gif">
		   <a href="javascript:void(1)" class="SB_Style_pwsbuttontext" style="text-decoration: none" >
            <xsl:attribute name="onclick">navigation_new_win('preview', '<xsl:value-of select="$baseURL"/><xsl:value-of select="$baseURL_SUFFIX"/><xsl:value-of select="/*/HEADER/TOP-MENU/TOP-MENU-STEP/PATH"/>', '<xsl:value-of select="/*/CONTENT-AREA/@PAGEID"/>');</xsl:attribute>
		   <xsl:value-of select="$previewButton/TITLE"/>   
		   </a>
		   </td>
           <td><img  border="0" src="{$baseURL}/images/pws_right.gif"/></td>
          </tr>
         </table>            
        
         </xsl:when>
         <xsl:otherwise>
          <table border="0" cellpadding="0" cellspacing="0" style="margin-left: 2px;">
          <xsl:attribute name="class">SB_Style_tablebuttonDisabled</xsl:attribute>
          <tr>
           <td><img  border="0" src="{$baseURL}/images/pws_left.gif"/></td>
           <td class="SB_Style_pwsbuttontext" background="{$baseURL}/images/pws_bg.gif"><xsl:value-of select="$previewButton/TITLE"/></td>
           <td><img  border="0" src="{$baseURL}/images/pws_right.gif"/></td>
          </tr>
         </table>            
         </xsl:otherwise>
         </xsl:choose>
           </xsl:when>

           <xsl:when test="$browser='OPERA'">
            <xsl:choose>
         <xsl:when test="$previewButton/ENABLED='TRUE'">
            <a style="text-decoration: none">
             <xsl:attribute name="href">javascript:navigation_new_win('preview','<xsl:value-of select="$baseURL"/><xsl:value-of select="$baseURL_SUFFIX"/><xsl:value-of select="/*/HEADER/TOP-MENU/TOP-MENU-STEP/PATH"/>','<xsl:value-of select="/*/CONTENT-AREA/@PAGEID"/>');</xsl:attribute>
          <table border="0" cellpadding="0" cellspacing="0" style="margin-left: 2px;">
          <xsl:attribute name="class">SB_Style_tablebutton</xsl:attribute>
          <tr>
           <td><img  border="0" src="{$baseURL}/images/pws_left.gif"/></td>
           <td class="SB_Style_pwsbuttontext" background="{$baseURL}/images/pws_bg.gif"><xsl:value-of select="$previewButton/TITLE"/></td>
           <td><img  border="0" src="{$baseURL}/images/pws_right.gif"/></td>
          </tr>
         </table>            
            </a>
           </xsl:when>
           <xsl:otherwise>
         <table border="0" cellpadding="0" cellspacing="0" style="margin-left: 2px;">
          <xsl:attribute name="class">SB_Style_tablebuttonDisabled</xsl:attribute>
          <tr>
           <td><img  border="0" src="{$baseURL}/images/pws_left.gif"/></td>
           <td class="SB_Style_pwsbuttontext" background="{$baseURL}/images/pws_bg.gif"><xsl:value-of select="$previewButton/TITLE"/></td>
           <td><img  border="0" src="{$baseURL}/images/pws_right.gif"/></td>
          </tr>
         </table>            
         </xsl:otherwise>
         </xsl:choose>
           </xsl:when>
           <xsl:otherwise>
         <table border="0" cellpadding="0" cellspacing="0" style="margin-left: 2px;">
          <xsl:choose>
           <xsl:when test="$previewButton/ENABLED='TRUE'">
            <xsl:attribute name="class">SB_Style_tablebutton</xsl:attribute>
             <xsl:attribute name="onclick">navigation_new_win('preview', '<xsl:value-of select="$baseURL"/><xsl:value-of select="$baseURL_SUFFIX"/><xsl:value-of select="/*/HEADER/TOP-MENU/TOP-MENU-STEP/PATH"/>', '<xsl:value-of select="/*/CONTENT-AREA/@PAGEID"/>');</xsl:attribute>
           </xsl:when>
           <xsl:otherwise>
            <xsl:attribute name="class">SB_Style_tablebuttonDisabled</xsl:attribute>
           </xsl:otherwise>
          </xsl:choose>
          <tr>
           <td><img  border="0" src="{$baseURL}/images/pws_left.gif"/></td>
           <td class="SB_Style_pwsbuttontext" background="{$baseURL}/images/pws_bg.gif"><xsl:value-of select="$previewButton/TITLE"/></td>
           <td><img  border="0" src="{$baseURL}/images/pws_right.gif"/></td>
          </tr>
         </table>
           </xsl:otherwise>
           </xsl:choose>

        </xsl:if>
       </xsl:otherwise>
      </xsl:choose>
     </td>
    </tr>
    </table>
   </td>
   <xsl:choose>
   <xsl:when test="/*/HEADER/TOP-MENU/PAGE-SHORT-HELP!=''">
    <xsl:choose>
     <xsl:when test="$browser='MOZILLA'">
      <td valign="top" width="5"><img  border="0" src="{$baseURL}/images/arrow_right.gif" style="padding-top: 7px;"/></td> 
      <td valign="top">
       <xsl:attribute name="class">SB_Style_short_help_Mozilla</xsl:attribute>
       <xsl:value-of select="/*/HEADER/TOP-MENU/PAGE-SHORT-HELP"/>
      </td> 
     </xsl:when>
     <xsl:otherwise>
      <td width="5"><img  border="0" src="{$baseURL}/images/arrow_right.gif" style="margin-left: 2px;margin-bottom:5 px;" /></td> 
      <td class="SB_Style_short_help_IE" valign="middle">
       <xsl:value-of select="/*/HEADER/TOP-MENU/PAGE-SHORT-HELP"/>
      </td> 
     </xsl:otherwise>
    </xsl:choose>
   </xsl:when>
   <xsl:otherwise>
   <td width="5">&#160;</td> 
   <td class="SB_Style_short_help" >
    &#160;
   </td>
   </xsl:otherwise>
   </xsl:choose>
  </tr> 
 </table>
</xsl:template>


<xsl:template name="LOGGED-USER-TEXT">
<table border="0" cellspacing="0" cellpadding="0">
<tr>
<td class="SB_Style_logged_title" style="padding-left:3px;">
  <xsl:value-of select="/*/*/LOGIN/USERNAME/@TITLE"/>:
</td>
<td class="SB_Style_logged_user" style="padding-left:3px;">
  <xsl:value-of select="/*/*/LOGIN/USERNAME"/>
</td>
</tr>
</table>
</xsl:template>
<!--


--> 

<xsl:template name="TOPIC-TITLE">
<xsl:param name="TITLE"/>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr>
 <td width="1">&#160;</td>
 <td class="colored" nowrap="1" width="40"><img src="{$baseURL}/images/empty.gif" width="2" height="1" border="0">
 </img><img border="0" src="{$baseURL}/images/title_arr.gif"/></td>
 <td class="colored" valign="middle"><xsl:value-of select="$TITLE"/></td>
 <td width="1">&#160;</td>
</tr>
</table>
</xsl:template>
<!--


-->
<xsl:template match="BOTTOM" name="BOTTOM-AREA">
 <table border="0" cellpadding="0" cellspacing="0" width="775" height="26">
  <tr valign="top">
   <td width="70%">
    <table width="100%" cellspacing="0" cellpadding="0" border="0">
     <tr>
       <xsl:choose>
       <xsl:when test='//FOOTER/STATUS'>
      <td background="{$baseURL}/images/footer_bg.gif"><img   border="0" height="43" width="15" src="{$baseURL}/images/footer_left.gif" /></td>
      <td background="{$baseURL}/images/footer_bg.gif" width="20"><span class="SB_Style_design_text">&#160;</span></td>
        <td background="{$baseURL}/images/footer_bg.gif" width="20" valign='middle'>
         <img id="stat_img" name="stat_img" border='0' width='23' height='23' style="margin-top: 10px;">
          <xsl:choose>
          <xsl:when test="$browser='MOZILLA'"><xsl:attribute name="style">margin-top:10px;</xsl:attribute></xsl:when>
          </xsl:choose>
<!--
          <xsl:attribute name="src"><xsl:value-of select="$baseURL"/><xsl:value-of select="//FOOTER/STATUS/@ICON"/></xsl:attribute>
-->
          <xsl:attribute name="src"><xsl:value-of select="//FOOTER/STATUS/@ICON"/></xsl:attribute>
         </img>
         <xsl:choose>
         <xsl:when test="$browser='MOZILLA'">
         </xsl:when>
         <xsl:otherwise>
         <div id='stat_img_ok' class="SB_Style_status_hidden"><img border='0' width='23' height='23' valign='middle' src='{$baseURL}/images/icon_info.gif'/></div>
         <div id='stat_img_stop' class="SB_Style_status_hidden"><img border='0' width='23' height='23' valign='middle' src='{$baseURL}/images/icon_stop.gif'/></div>
         </xsl:otherwise>
         </xsl:choose>
         </td>
      <td background="{$baseURL}/images/footer_bg.gif" width='98%' nowrap='nowrap' valign='middle' style="padding-top: 10px;"><span class="SB_Style_design_text">&#160;</span><span id='status_message' class='SB_Style_status'><xsl:value-of select="//FOOTER/STATUS/@MESSAGE"/></span></td>
      <td background="{$baseURL}/images/footer_bg.gif" width="1"><img width="1" height="36" src="{$baseURL}/images/empty.gif" border="0" valign="top" alt=""/></td>
      <td background="{$baseURL}/images/footer_bg.gif" width="1" nowrap="nowrap"><img src="{$baseURL}/images/footer_right.gif" width="86" height="43" border="0" alt=""/></td>
       </xsl:when>
       <xsl:otherwise>
      <td background="{$baseURL}/images/footer_bg.gif"><img   border="0" height="43" width="15" src="{$baseURL}/images/footer_left.gif" /></td>
      <xsl:choose>
      <xsl:when test="$browser='OPERA'">
      <td background="{$baseURL}/images/footer_bg.gif" width="20" valign='middle'><img border='0' width='29' height='1' valign='top' src='{$baseURL}/images/empty.gif'/>
       <div id='stat_img_ok' class="SB_Style_status_hidden_opera"><img  border='0' width='23' height='23' valign='middle' src='{$baseURL}/images/icon_info.gif'/></div>
       <div id='stat_img_stop' class="SB_Style_status_hidden_opera"><img  border='0' width='23' height='23' valign='middle' src='{$baseURL}/images/icon_stop.gif'/></div>
      </td>
      </xsl:when>
      <xsl:when test="$browser='MOZILLA'">
      <td background="{$baseURL}/images/footer_bg.gif" width="20" valign='middle'>
       <img id="stat_img" name="stat_img" border='0' align='right' width='23' height='23' src='{$baseURL}/images/empty.gif' style="margin-left:5px; margin-top: 10px;"/>
      </td>
      </xsl:when>

      <xsl:otherwise>
      <td background="{$baseURL}/images/footer_bg.gif" width="20" valign='middle'>
       <img id="stat_img" name="stat_img" border='0' align='right' width='23' height='23' src='{$baseURL}/images/empty.gif' style="margin-left:5px; margin-top: 10px;"/>
       <div id='stat_img_ok' class="SB_Style_status_hidden"><img name="stat_img" align='right' border='0' width='23' height='23' valign='middle' src='{$baseURL}/images/icon_info.gif'/></div>
       <div id='stat_img_stop' class="SB_Style_status_hidden"><img name="stat_img" align='right' border='0' width='23' height='23' valign='middle' src='{$baseURL}/images/icon_stop.gif'/></div>
      </td>
      </xsl:otherwise>
      </xsl:choose>
      <td background="{$baseURL}/images/footer_bg.gif" width="23" style="padding-top: 10px;" valign='middle'></td>
      <td background="{$baseURL}/images/footer_bg.gif" width='98%' nowrap='true' valign='middle' style="padding-top: 10px;padding-right: 0px;padding-left: 0px;padding-bottom: 0px; padding-left:6px">&#160;<span id='status_message' class='SB_Style_status' nowrap='true' ></span></td>
      <td background="{$baseURL}/images/footer_bg.gif" width="1"><img width="1" height="1" src="{$baseURL}/images/empty.gif" border="0" valign="top" alt=""/></td>
      <td background="{$baseURL}/images/footer_bg.gif" width="1" nowrap="nowrap"><img src="{$baseURL}/images/footer_right.gif" width="86" height="43" border="0" alt=""/></td>
       </xsl:otherwise>
       </xsl:choose>
     </tr>
    </table>
   </td>
   <td width="30%" height="43" valign="middle" background="{$baseURL}/images/footer_button_bg.gif">
    <table border="0" cellpadding="0" cellspacing="0" height="43" width="100%" valign="middle" >
     <tr>
      <xsl:choose>
       <xsl:when test='*/FOOTER/FOOTER-BUTTON'>
      <xsl:for-each select="*/FOOTER/FOOTER-BUTTON">
       <xsl:if test="@NAME[.='back']">
        
        <xsl:choose>
        <xsl:when test="$browser='MOZILLA'">

        <td align="right"><a  href="javascript:void(1)" style="text-decoration: none;" >
         <xsl:attribute name="onClick">javascript:navigation('<xsl:value-of select="@MODE"/>', '<xsl:value-of select="$baseURL"/><xsl:value-of select="$baseURL_SUFFIX"/><xsl:value-of select="@PATH"/>','<xsl:value-of select="/*/CONTENT-AREA/@PAGEID"/>');</xsl:attribute>         
         <table border="0" cellpadding="0" cellspacing="0" class="SB_Style_tablebutton">
          <tr>
           <td><img src="{$baseURL}/images/button_back_left.gif" border="0"/></td>
           <td align="center" nowrap="nowrap" width="75" class="SB_Style_footer_button_text" background="{$baseURL}/images/button_back_middle.gif"><xsl:value-of select="."/></td>
           <td><img src="{$baseURL}/images/button_back_right.gif" border="0"/></td>
          </tr>
         </table></a></td>

        </xsl:when> <xsl:otherwise>

        <td align="right">
         <table border="0" cellpadding="0" cellspacing="0" class="SB_Style_tablebutton">
          <xsl:attribute name="onclick">javascript:navigation('<xsl:value-of select="@MODE"/>', '<xsl:value-of select="$baseURL"/><xsl:value-of select="$baseURL_SUFFIX"/><xsl:value-of select="@PATH"/>','<xsl:value-of select="/*/CONTENT-AREA/@PAGEID"/>');</xsl:attribute>
          <tr>
           <td><img src="{$baseURL}/images/button_back_left.gif" border="0"/></td>
           <td align="center" nowrap="nowrap" width="75" class="SB_Style_footer_button_text" background="{$baseURL}/images/button_back_middle.gif"><xsl:value-of select="."/></td>
           <td><img src="{$baseURL}/images/button_back_right.gif" border="0"/></td>
          </tr>
         </table>
        </td>
        
        </xsl:otherwise>
        </xsl:choose>         
        
        <td width="2"><span class="SB_Style_design_text">&#160;</span></td>
       </xsl:if>
       <xsl:if test="@NAME[.='next']">
        <xsl:choose>
        <xsl:when test='@DISABLED[.="TRUE"]'>
        <td background="{$baseURL}/images/footer_button_bg.gif"  align="right">
         <table border="0" cellpadding="0" cellspacing="0">
           <tr>
           <td><img  border="0"  src="{$baseURL}/images/button_next_left.gif"/></td>
           <td align="center" nowrap="nowrap" width="75" class="SB_Style_footer_button_text_disabled" background="{$baseURL}/images/button_next_middle.gif"><xsl:value-of select="."/></td>
           <td><img   border="0" src="{$baseURL}/images/button_next_right_dis.gif"/></td>
          </tr>
         </table>
        </td>
        <td width="2">&#160;</td>
        </xsl:when>
        <xsl:otherwise>
        
        <xsl:choose>
        <xsl:when test="$browser='MOZILLA'">

         <td  align="right"><a href="javascript:void(1)" style="text-decoration: none;" >
           <xsl:attribute name="onClick">javascript:navigation('<xsl:value-of select="@MODE"/>', '<xsl:value-of select="$baseURL"/><xsl:value-of select="$baseURL_SUFFIX"/><xsl:value-of select="@PATH"/>','<xsl:value-of select="/*/CONTENT-AREA/@PAGEID"/>');</xsl:attribute>
          <table border="0" cellpadding="0" cellspacing="0" class="SB_Style_tablebutton">
          <tr>
            <td><img src="{$baseURL}/images/button_next_left.gif"  border="0"/></td>
            <td align="center" nowrap="nowrap" width="75" class="SB_Style_footer_button_text" background="{$baseURL}/images/button_next_middle.gif"><xsl:value-of select="."/></td>
            <td><img src="{$baseURL}/images/button_next_right.gif" border="0"/></td>
           </tr>
          </table></a></td>
        
        </xsl:when><xsl:otherwise>
        
        <td  align="right">
         <table border="0" cellpadding="0" cellspacing="0" class="SB_Style_tablebutton">
          <xsl:attribute name="onclick">navigation('<xsl:value-of select="@MODE"/>','<xsl:value-of select="$baseURL"/><xsl:value-of select="$baseURL_SUFFIX"/><xsl:value-of select="@PATH"/>', '<xsl:value-of select="/*/CONTENT-AREA/@PAGEID"/>');</xsl:attribute>
           <tr>
            <td><img src="{$baseURL}/images/button_next_left.gif"  border="0"/></td>
            <td align="center" nowrap="nowrap" width="75" class="SB_Style_footer_button_text" background="{$baseURL}/images/button_next_middle.gif"><xsl:value-of select="."/></td>
            <td><img src="{$baseURL}/images/button_next_right.gif" border="0"/></td>
          </tr>
         </table>
        </td>
        </xsl:otherwise>
        </xsl:choose>
        
        <td width="2">&#160;</td>
        </xsl:otherwise>
        </xsl:choose>
       </xsl:if>
      </xsl:for-each>

       </xsl:when>
       <xsl:otherwise>
        <td align="right">&#160;</td>
       </xsl:otherwise>
      </xsl:choose>
     </tr>
    </table>
   </td>
   <xsl:for-each select="//SCRIPT-DATA">
    <script type="text/javascript" language='Javascript'>
     <xsl:value-of select="."/>
	</script>
   </xsl:for-each>
  </tr>
 </table>
</xsl:template>
<!--


-->
<xsl:template match="FORM-TITLE">
<tr>
 <td align="center" colspan="4" class="bigtitle"><xsl:value-of select="."/></td>
</tr>
</xsl:template>
<!--


-->
<xsl:template match="FIELD">
<xsl:choose>
 <xsl:when test="@TYPE[.='hidden']">
  <xsl:call-template name="HIDDEN"/>
 </xsl:when><xsl:otherwise>
  <tr>
   <td nowrap="nowrap" align="center" width="1%">
   <xsl:choose>
    <xsl:when test="@REQUIRED='1'"><span class="required">&#160;*&#160;</span></xsl:when>
    <xsl:otherwise><span class="required">&#160;</span></xsl:otherwise>
   </xsl:choose>
   </td>
   <td align="right" class="data">
    <xsl:if test="@TITLE">
     <font class="SB_Style_000000"><xsl:value-of select="@TITLE"/>:&#160;</font>
    </xsl:if>
   </td>
   <td align="left">
    <xsl:choose>
     <xsl:when test="@TYPE[.='list']">
      <xsl:call-template name="COMBOBOX"/>
     </xsl:when>
     <xsl:when test="@TYPE[.='pswd']">
      <xsl:call-template name="PSWDBOX"/>
     </xsl:when>
     <xsl:when test="@TYPE[.='area']">
      <xsl:call-template name="TEXTAREA"/>
     </xsl:when>
     <xsl:when test="@TYPE[.='check']">
      <xsl:call-template name="CHECKBOX"/>
     </xsl:when>
     <xsl:otherwise>
      <xsl:call-template name="TEXTBOX"/>
     </xsl:otherwise>
    </xsl:choose>
   </td>
  </tr>
 </xsl:otherwise>
</xsl:choose>
</xsl:template>


<xsl:template match="FIELD" mode="selector">
<xsl:choose>
 <xsl:when test="@TYPE[.='hidden']">
 <!-- no op -->
 </xsl:when><xsl:otherwise>
 <xsl:if test="@TITLE">
 <td width="1%" nowrap="nowrap" align="right" class="data"><font class="SB_Style_000000"><xsl:value-of select="@TITLE"/>:&#160;&#160;</font></td></xsl:if>
 <td width="1%" align="left">
 <xsl:choose>
     <xsl:when test="@TYPE[.='list']">
      <xsl:call-template name="COMBOBOX"/>
     </xsl:when>
     <xsl:when test="@TYPE[.='pswd']">
      <xsl:call-template name="PSWDBOX"/>
     </xsl:when>
     <xsl:when test="@TYPE[.='area']">
      <xsl:call-template name="TEXTAREA"/>
     </xsl:when>
     <xsl:when test="@TYPE[.='check']">
      <xsl:call-template name="CHECKBOX"/>
     </xsl:when>
     <xsl:when test="@TYPE[.='file']">
      <xsl:call-template name="FILE"/>
     </xsl:when>     <xsl:otherwise>
      <xsl:call-template name="TEXTBOX"/>
     </xsl:otherwise>
    </xsl:choose>
 </td>
</xsl:otherwise>
</xsl:choose>
</xsl:template>
<!--


-->
<xsl:template match="FORM-FIELD" name="FILE" mode="file">
<input type="file" class="SB_Style_formfield">
 <xsl:call-template name="setTabIndex"/>
 <xsl:if test="@DISABLED and @DISABLED='true'"><xsl:attribute name="disabled">disabled</xsl:attribute></xsl:if>
 <xsl:if test="@MAXLENGTH"><xsl:attribute name="maxlength"><xsl:value-of select="@MAXLENGTH"/></xsl:attribute></xsl:if>
 <xsl:attribute name="name"><xsl:value-of select="@NAME"/></xsl:attribute>
 <xsl:attribute name="ID"><xsl:value-of select="@ID"/></xsl:attribute>
 <xsl:attribute name="SIZE"><xsl:value-of select="@SIZE"/></xsl:attribute>
 <xsl:attribute name="STYLE"><xsl:value-of select="@STYLE"/></xsl:attribute>
 <xsl:attribute name="value"><xsl:value-of select="@VALUE"/></xsl:attribute>
 <xsl:attribute name="class"><xsl:value-of select="@CLASS"/></xsl:attribute>
 <xsl:attribute name="onChange"><xsl:value-of select="@ONCHANGE"/></xsl:attribute>
 <xsl:attribute name="onKeyup"><xsl:value-of select="@ONKEYUP"/></xsl:attribute>
</input>
</xsl:template>
<!--


-->
<xsl:template match="FORM-FIELD" name="TEXTBOX" mode="text">
<input type="text" class="SB_Style_formfield">
 <xsl:call-template name="setTabIndex"/>
 <xsl:if test="@DISABLED and @DISABLED='true'"><xsl:attribute name="disabled">disabled</xsl:attribute></xsl:if>
 <xsl:if test="@MAXLENGTH"><xsl:attribute name="maxlength"><xsl:value-of select="@MAXLENGTH"/></xsl:attribute></xsl:if>
 <xsl:attribute name="name"><xsl:value-of select="@NAME"/></xsl:attribute>
 <xsl:attribute name="SIZE"><xsl:value-of select="@SIZE"/></xsl:attribute>
 <xsl:attribute name="STYLE"><xsl:value-of select="@STYLE"/></xsl:attribute>
 <xsl:attribute name="value"><xsl:value-of select="@VALUE"/></xsl:attribute>
 <xsl:attribute name="class"><xsl:value-of select="@CLASS"/></xsl:attribute>
 <xsl:attribute name="onChange"><xsl:value-of select="@ONCHANGE"/></xsl:attribute>
 <xsl:attribute name="onKeyup"><xsl:value-of select="@ONKEYUP"/></xsl:attribute>
</input>
</xsl:template>
<!--


-->
<xsl:template match="FORM-FIELD" name="TEXTDATA" mode="text">
<span>
 <xsl:attribute name="STYLE"><xsl:value-of select="@STYLE"/></xsl:attribute>
 <xsl:attribute name="class"><xsl:value-of select="@CLASS"/></xsl:attribute>
 <xsl:value-of select="@VALUE"/>
</span> 
</xsl:template>
<!--


-->
<xsl:template match="FORM-FIELD" name="TEXTAREA" mode="area">
<textarea class="SB_Style_formfield">
 <xsl:attribute name="name"><xsl:value-of select="@NAME"/></xsl:attribute>
 <xsl:attribute name="STYLE"><xsl:value-of select="@STYLE"/></xsl:attribute>
 <xsl:attribute name="value"><xsl:value-of select="@VALUE"/></xsl:attribute>
 <xsl:value-of select="@VALUE"/>
 <xsl:attribute name="onKeyup"><xsl:value-of select="@ONKEYUP"/></xsl:attribute>
</textarea>
</xsl:template>
<!--


-->
<xsl:template match="FORM-FIELD" name="PSWDBOX" mode="pswd">
<input type="password" class="SB_Style_formfield" maxlength="">
 <xsl:call-template name="setTabIndex"/>
 <xsl:if test="@DISABLED and @DISABLED='true'"><xsl:attribute name="disabled">disabled</xsl:attribute></xsl:if>
 <xsl:if test="@MAXLENGTH"><xsl:attribute name="maxlength"><xsl:value-of select="@MAXLENGTH"/></xsl:attribute></xsl:if>
 <xsl:attribute name="name"><xsl:value-of select="@NAME"/></xsl:attribute>
 <xsl:attribute name="SIZE"><xsl:value-of select="@SIZE"/></xsl:attribute>
 <xsl:attribute name="STYLE"><xsl:value-of select="@STYLE"/></xsl:attribute>
 <xsl:attribute name="value"><xsl:value-of select="@VALUE"/></xsl:attribute>
 <xsl:attribute name="onKeyup"><xsl:value-of select="@ONKEYUP"/></xsl:attribute>
</input>
</xsl:template>

<!--


-->
<xsl:template match="FORM-FIELD" name="HIDDEN" mode="hidden">
<input type="hidden">
 <xsl:attribute name="id"><xsl:value-of select="@ID"/></xsl:attribute>
 <xsl:attribute name="name"><xsl:value-of select="@NAME"/></xsl:attribute>
 <xsl:attribute name="value"><xsl:value-of select="@VALUE"/></xsl:attribute>
</input>
</xsl:template>
<!--
////
-->
<xsl:template name="setTabIndex">
<!--
<xsl:param name="lastTabIndex" select="'0'"/>
<xsl:variable name="curIndex"><xsl:number level="any" count="FORM-FIELD|FIELD|SEARCH-FIELD" format="1" from="PAGE-CONTENT"/></xsl:variable>
<xsl:attribute name="tabIndex"><xsl:value-of select="$lastTabIndex + $curIndex"/></xsl:attribute>
-->
</xsl:template>

<!--


-->
<xsl:template match="FORM-FIELD" name="CHECKBOX" mode="check">
<input type="checkbox" class="SB_Style_checkbox">
 <xsl:call-template name="setTabIndex"/>
 <xsl:if test="@DISABLED and @DISABLED='true'">
  <xsl:attribute name="disabled">disabled</xsl:attribute>
 </xsl:if>
 <xsl:attribute name="name"><xsl:value-of select="@NAME"/></xsl:attribute>
 <xsl:attribute name="value"><xsl:value-of select="@VALUE"/></xsl:attribute>
 <xsl:if test="@CHECKED='true'">
  <xsl:attribute name="checked">true</xsl:attribute>
 </xsl:if>
 <xsl:attribute name="style"><xsl:value-of select="@STYLE"/></xsl:attribute>
 <xsl:attribute name="onKeyup"><xsl:value-of select="@ONKEYUP"/></xsl:attribute>
 <xsl:attribute name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:attribute>
</input>
</xsl:template>
<!--


-->
<xsl:template match="FORM-FIELD" name="COMBOBOX" mode="list">
<xsl:param name="node" select="."/>
<xsl:param name="tabIndex" select="'1'"/>
<select size="1" name="{$node/@NAME}" class="{$node/@CLASS}">
 <xsl:call-template name="setTabIndex"/>
 <xsl:if test="@ONCHANGE and not( @ONCHANGE = '' )">
  <xsl:attribute name="onchange"><xsl:value-of select="@ONCHANGE"/></xsl:attribute>
 </xsl:if>
 <xsl:if test="@DISABLED and @DISABLED='true'">
  <xsl:attribute name="disabled">disabled</xsl:attribute>
 </xsl:if>
 <xsl:if test="$node/@STYLE">
  <xsl:attribute name="STYLE"><xsl:value-of select="$node/@STYLE"/></xsl:attribute>
 </xsl:if>
 <xsl:if test="$node/@WIDTH">
  <xsl:attribute name="WIDTH"><xsl:value-of select="$node/@WIDTH"/></xsl:attribute>
 </xsl:if>
 <xsl:for-each select="$node/ITEM">
  <option>
   <xsl:attribute name="value"><xsl:value-of select="@VALUE"/></xsl:attribute>
   <xsl:if test="@SELECTED='1'">
    <xsl:attribute name="selected">1</xsl:attribute>
   </xsl:if>
   <xsl:value-of select="."/>
  </option>
 </xsl:for-each>
</select>
</xsl:template>
<!--


-->
<xsl:template match="/*/DEBUG">
 <xsl:apply-templates/>
</xsl:template>
<!--

-->
<xsl:template match="SCRIPT">
<script>
 <xsl:value-of select="."/> 
</script>
</xsl:template>

<xsl:template match="/*/CONTENT-AREA">
 <xsl:apply-templates/>
</xsl:template>
<!--


-->
<xsl:template match="FREE-CONTENT">
 <xsl:value-of disable-output-escaping="yes" select="*|@*|comment()|text()"/>
</xsl:template>
<!--


-->
<xsl:template match="TOPICS">
<table border="0" cellpadding="0" cellspacing="0" width="90%">
<xsl:for-each select="CONTENT-TOPIC">
 <tr>
  <td class="content-topic">
   <a class="content-topic">
    <xsl:attribute name="href"><xsl:value-of select="@ACTION"/></xsl:attribute>
    <xsl:value-of select="@TITLE"/>
   </a>
  </td>
 </tr>
</xsl:for-each>
</table>
</xsl:template>
<!--


-->
<xsl:template match="CONTENT-TOPIC">
</xsl:template>
<!--


-->
<xsl:template match="/*/INFO-PANEL">
<img src="{$baseURL}/images/empty.gif" width="5" border="0"/>
<xsl:apply-templates/>
</xsl:template>
<!--


-->
<xsl:template match="HELP-TOPIC">
<xsl:call-template name="TOPIC-TITLE">
 <xsl:with-param name="TITLE">
  <xsl:apply-templates select="TITLE"/>
 </xsl:with-param>
</xsl:call-template>
<p class="content"><xsl:value-of select="MESSAGE"/></p>
</xsl:template>
<!--


-->
<!--
/////
-->
<xsl:template match="PAGE-STRIP">
<table cellspacing="0" cellpadding="0" border="0" width="100%">
<tr>
  <td width="1%" nowrap="nowrap" valign="middle" class="SB_Style_formtitle"  style="padding-left:5px; padding-right:10px;"><xsl:value-of select="PAGE-SIZE"/>&#160;<xsl:apply-templates select="PAGE-S" mode="page-strip"/>&#160;&#160;&#160;</td>
 <td width="1%" nowrap="nowrap" valign="middle" class="SB_Style_formtitle"  style="padding-left:5px; padding-right:10px;"><xsl:value-of select="BRS"/></td>
 <td width="1%" nowrap="nowrap"><img src="{$baseURL}/images/empty.gif" width="5" border="0"/></td>
 <td width="1%" nowrap="nowrap"><xsl:apply-templates select="FIRST-PAGE"  mode="page-strip"/></td>
 <td width="1%" nowrap="nowrap"><img src="{$baseURL}/images/empty.gif" width="5" border="0"/></td>
 <td width="93%" nowrap="nowrap" height="22px" valign="middle" class="SB_Style_formtitle" align="center">
  <xsl:apply-templates select="PREV-PAGE-SET" mode="page-strip"/>
<!-- <xsl:apply-templates select="PREV-PAGE" mode="page-strip"/> -->
  <xsl:apply-templates select="PAGE" mode="page-strip"/>
<!-- <xsl:apply-templates select="NEXT-PAGE" mode="page-strip"/> -->
  <xsl:apply-templates select="NEXT-PAGE-SET" mode="page-strip"/>
 </td>
 <td width="1%" nowrap="nowrap"><img src="{$baseURL}/images/empty.gif" width="5" border="0"/></td>
 <td width="1%" nowrap="nowrap"><xsl:apply-templates select="LAST-PAGE"  mode="page-strip"/></td>
 <td width="1%" nowrap="nowrap"><img src="{$baseURL}/images/empty.gif" width="5" border="0"/></td>
</tr>
</table>
</xsl:template>
<!--
/////
-->
<xsl:template match="PREV-PAGE-SET" mode="page-strip">
<xsl:choose>
 <xsl:when test="@URL"><a href="{$baseURL}{@URL}" class="SB_Style_browse_page" onclick="dc();">&lt;&lt;</a>&#160;</xsl:when>
<!-- <xsl:otherwise><font style="color:gray">&lt;&lt;</font>&#160;</xsl:otherwise> -->
 <xsl:otherwise></xsl:otherwise>
</xsl:choose>
</xsl:template>
<!--
/////
-->
<xsl:template match="PREV-PAGE" mode="page-strip">
<xsl:choose>
 <xsl:when test="@URL"><a href="{$baseURL}{@URL}" class="SB_Style_browse_page" onclick="dc();">&lt;</a>&#160;</xsl:when>
<!-- <xsl:otherwise><span class="SB_Style_DisabledText">&lt;&lt;</span>&#160;</xsl:otherwise> -->
 <xsl:otherwise></xsl:otherwise>
</xsl:choose>
</xsl:template>
<!--
/////
-->
<xsl:template match="NEXT-PAGE-SET" mode="page-strip">
<xsl:choose>
 <xsl:when test="@URL"><a href="{$baseURL}{@URL}" class="SB_Style_browse_page" onclick="dc();">&gt;&gt;</a>&#160;</xsl:when>
<!-- <xsl:otherwise><span class="SB_Style_DisabledText">&gt;&gt;</span></xsl:otherwise> -->
 <xsl:otherwise></xsl:otherwise>
</xsl:choose>
</xsl:template>
<!--
/////
-->
<xsl:template match="NEXT-PAGE" mode="page-strip">
<xsl:choose>
 <xsl:when test="@URL"><a href="{$baseURL}{@URL}" class="SB_Style_browse_page" onclick="dc();">&gt;</a>&#160;</xsl:when>
<!-- <xsl:otherwise><span class="SB_Style_DisabledText">&gt;&gt;</span></xsl:otherwise> -->
 <xsl:otherwise></xsl:otherwise>
</xsl:choose>
</xsl:template>
<!--
/////
-->
<xsl:template match="FIRST-PAGE|LAST-PAGE" mode="page-strip">
<xsl:choose>
 <xsl:when test="@URL">&#160;<a href="{$baseURL}{@URL}" class="SB_Style_browse_page" onclick="dc();"><xsl:value-of select="@CAPTION"/></a>&#160;</xsl:when>
<!-- <xsl:otherwise><td valign="middle">&#160;<span class="SB_Style_DisabledText"><xsl:value-of select="@CAPTION"/></span>&#160;</td></xsl:otherwise> -->
 <xsl:otherwise></xsl:otherwise>
</xsl:choose>
</xsl:template>
<!--
/////
-->
<xsl:template match="PAGE" mode="page-strip">
<xsl:choose>
 <xsl:when test="@CURRENT='true'"><b>
 <span class="SB_Style_AlertText"><xsl:value-of select="."/></span></b></xsl:when>
 <xsl:otherwise><a href="{$baseURL}{@URL}" class="SB_Style_browse_page" onclick="dc();"><xsl:value-of select="."/></a></xsl:otherwise>
</xsl:choose>&#160;
</xsl:template>


<xsl:template match="PAGE-S" mode="page-strip">
<xsl:choose>
 <xsl:when test="@CURRENT='true'"><b>
 <span class="SB_Style_AlertText"><xsl:value-of select="."/></span></b></xsl:when>
 <xsl:otherwise><a href="{$baseURL}{@URL}" class="SB_Style_browse_page" onclick="dc();"><xsl:value-of select="."/></a></xsl:otherwise>
</xsl:choose>&#160;
</xsl:template>


<!--


-->
<xsl:template name="IMAGE-MENU-ITEM">
<td width="1"><a class="content-menu">
 <xsl:if test="not(@ENABLED) or @ENABLED='true'">
  <xsl:attribute name="href"><xsl:value-of select="@ACTION"/></xsl:attribute>
  <xsl:if test="@ONCLICK">
   <xsl:attribute name="onclick"><xsl:value-of select="@ONCLICK"/></xsl:attribute>
  </xsl:if>
 </xsl:if>
 <img border="0">
  <xsl:attribute name="src"><xsl:value-of select="$baseURL"/><xsl:value-of select="@IMAGE"/></xsl:attribute>
 </img></a></td>
<td class="content-menu" nowrap="1"><a class="content-menu">
 <xsl:if test="not(@ENABLED) or @ENABLED='true'">
  <xsl:attribute name="href"><xsl:value-of select="@ACTION"/></xsl:attribute>
  <xsl:if test="@ONCLICK">
   <xsl:attribute name="onclick"><xsl:value-of select="@ONCLICK"/></xsl:attribute>
  </xsl:if>
 </xsl:if>
 <xsl:value-of select="."/>
 </a></td>
</xsl:template>

<xsl:template match="TOOLBAR">
 <table cellspacing="0" cellpadding="0" border="0" height="21" background="{$baseURL}/images/toolbar_bg.gif">
  <tr>
 <td height="21" align="center"><img src="{$baseURL}/images/toolbar_left.gif" height="21" border="0"/></td>
    <xsl:choose>
    <xsl:when test="$browser='MOZILLA'">
      <xsl:for-each select="ITEM">
      <td><a href="javascript:void(1)" style="text-decoration: none"  >
      <xsl:choose>
     <xsl:when test="substring-before(@HREF,':')='javascript'">
      <xsl:attribute name="onclick"><xsl:value-of select="@HREF"/></xsl:attribute>
     </xsl:when>
     <xsl:otherwise>
      <xsl:attribute name="onclick">document.location.href = '<xsl:value-of select="$baseURL"/><xsl:value-of select="$baseURL_SUFFIX"/><xsl:value-of select="@HREF"/>';</xsl:attribute>
     </xsl:otherwise>
    </xsl:choose>
      <table cellspacing="0" cellpadding="0" border="0" style="margin-left:5px; margin-right:5px;" class="SB_Style_tablebutton">
      <xsl:attribute name="onmouseover">javascript:doOver(this);</xsl:attribute>
      <xsl:attribute name="onmouseout">javascript:doOut(this);</xsl:attribute>
      <tr>
    <td align="right" width="16"><img height="21" width="16" border="0"><xsl:attribute name="src"><xsl:value-of select="@ICON"/></xsl:attribute></img></td>
    <td align="center" class="SB_Style_toolbarbutton">&#160;&#160;<xsl:value-of select="."/></td>
      </tr>
      </table>
      </a></td>
   </xsl:for-each>
    </xsl:when>
    <xsl:when test="$browser='OPERA'">
      <xsl:for-each select="ITEM">
      <td><a href="javascript:void(1)" style="text-decoration: none"  >
      <xsl:choose>
     <xsl:when test="substring-before(@HREF,':')='javascript'">
      <xsl:attribute name="onclick"><xsl:value-of select="@HREF"/></xsl:attribute>
     </xsl:when>
     <xsl:otherwise>
      <xsl:attribute name="onclick">document.location.href='<xsl:value-of select="$baseURL"/><xsl:value-of select="$baseURL_SUFFIX"/><xsl:value-of select="@HREF"/>';</xsl:attribute>
     </xsl:otherwise>
    </xsl:choose>
      <table cellspacing="0" cellpadding="0" border="0" style="margin-left:5px; margin-right:5px;" class="SB_Style_tablebutton">
      <xsl:attribute name="onmouseover">doOver(this);</xsl:attribute>
      <xsl:attribute name="onmouseout">doOut(this);</xsl:attribute>
      <tr>
    <td align="right" width="16"><img height="21" width="16" border="0"><xsl:attribute name="src"><xsl:value-of select="@ICON"/></xsl:attribute></img></td>
    <td align="center" class="SB_Style_toolbarbutton">&#160;&#160;<xsl:value-of select="."/></td>
      </tr>
      </table>
      </a></td>
   </xsl:for-each>
    </xsl:when>
    <xsl:otherwise>
   <xsl:for-each select="ITEM">
      <td>
      <table cellspacing="0" cellpadding="0" border="0" style="margin-left:5px; margin-right:5px;" class="SB_Style_tablebutton">
      <xsl:attribute name="onmouseover">javascript:doOver(this);</xsl:attribute>
      <xsl:attribute name="onmouseout">javascript:doOut(this);</xsl:attribute>
      <xsl:choose>
     <xsl:when test="substring-before(@HREF,':')='javascript'">
      <xsl:attribute name="onclick"><xsl:value-of select="@HREF"/></xsl:attribute>
     </xsl:when>
     <xsl:otherwise>
      <xsl:attribute name="onclick">document.location.href = '<xsl:value-of select="$baseURL"/><xsl:value-of select="$baseURL_SUFFIX"/><xsl:value-of select="@HREF"/>';</xsl:attribute>
     </xsl:otherwise>
    </xsl:choose>
      <tr>
    <td align="right" width="16"><img height="21" width="16" border="0"><xsl:attribute name="src"><xsl:value-of select="@ICON"/></xsl:attribute></img></td>
    <td align="center" class="SB_Style_toolbarbutton">&#160;&#160;<xsl:value-of select="."/></td>
      </tr>
      </table></td>
   </xsl:for-each>
    </xsl:otherwise>
    </xsl:choose>
  </tr>
 </table>
</xsl:template>



<xsl:template match="MESSAGE">
<table border="0" cellpadding="5" cellspacing="0" width="100%">
 <tr>
  <td width="99%">
   <p><span class="{@TYPE}MessageTitle"><xsl:value-of select="@TITLE"/>:&#160;</span><xsl:value-of select="."/></p>
  </td>
 </tr>
</table>
</xsl:template>


<xsl:template name="drawButton">
<xsl:param name="name" select="''"/>
<xsl:param name="id" select="'bid-none'"/>
<xsl:param name="onClick">void(1);</xsl:param>
<xsl:param name="caption">UNKNOWN</xsl:param>
<xsl:param name="ButtonIcon"><xsl:value-of select="$baseURL"/>/images/1x1.gif</xsl:param>
<xsl:param name="conHelp" select="''"/>
<xsl:if test="$name != ''">
 <input type='hidden' name='$name' value='1'/>
</xsl:if>

<xsl:choose><xsl:when test="$browser='MOZILLA'"> 
 <!--<a href="javascript:void(1)" style="text-decoration: none">
 <xsl:attribute name="onClick"><xsl:value-of select="$onClick"/></xsl:attribute>-->
<table border="0" cellpadding="0" cellspacing="0" >
 <tr>
  <td nowrap='nowrap' width="100%">
  <a href="javascript:void(1)" class="commonButton" style='text-decoration: none;'>
	<xsl:attribute name="onClick"><xsl:value-of select="$onClick"/></xsl:attribute>
	<xsl:attribute name="onmouseover">mouse_move(&#039;<xsl:value-of select="$conHelp"/>&#039;)</xsl:attribute>
	<xsl:attribute name="onmouseout">mouse_move()</xsl:attribute>
	<xsl:attribute name="title"><xsl:value-of select="$caption"/></xsl:attribute>
	<img src="{$ButtonIcon}" border="0" style="vertical-align: middle;" />&#160;
	<div class="commonButton" style='text-decoration: underline; vertical-align: middle;'>
	<xsl:value-of select="$caption"/>
	</div>&#160;&#160;
  </a>
 </td>
 </tr>
 </table>
</xsl:when>
<xsl:when test="$browser='OPERA'">
 <a style="text-decoration: none" href="#">
	<xsl:attribute name="title">
		<xsl:value-of select="$caption"/>
	</xsl:attribute>
 <xsl:attribute name="onClick"><xsl:value-of select="$onClick"/></xsl:attribute>
 <xsl:attribute name="onmouseover">mouse_move(&#039;<xsl:value-of select="$conHelp"/>&#039;)</xsl:attribute>
 <xsl:attribute name="onmouseout">mouse_move()</xsl:attribute>

 <table border="0" cellpadding="0" cellspacing="0" style="cursor :  hand;">
 <tr>
  <td><img src="{$ButtonIcon}" border="0" style="vertical-align: middle;">
	<xsl:attribute name="title">
		<xsl:value-of select="$caption"/>
	</xsl:attribute></img>&#160;</td>
  <td nowrap='nowrap' class="commonButton" align='middle' >
  <span style='text-decoration: underline;'><xsl:value-of select="$caption"/></span>&#160;&#160;</td>
 </tr>
 </table></a>
</xsl:when>

<xsl:otherwise>
 <table border="0" cellpadding="0" cellspacing="0" style="cursor :  hand;">
 <xsl:attribute name="onclick"><xsl:value-of select="$onClick"/></xsl:attribute>
 <xsl:attribute name="onmouseover">mouse_move(&#039;<xsl:value-of select="$conHelp"/>&#039;)</xsl:attribute>
 <xsl:attribute name="onmouseout">mouse_move()</xsl:attribute>

 <tr>
  <td><img src="{$ButtonIcon}" border="0" style="vertical-align: middle;">
	<xsl:attribute name="title">
		<xsl:value-of select="$caption"/>
	</xsl:attribute></img>&#160;</td>
  <td nowrap='nowrap' class="commonButton" align='middle' >
	<div class="commonButton" style='text-decoration: underline;'>
	<xsl:attribute name="title">
		<xsl:value-of select="$caption"/>
	</xsl:attribute>
	<span>
		<xsl:value-of select="$caption"/>
	</span>
	</div>&#160;&#160;
	</td>
 </tr>
 </table>
</xsl:otherwise></xsl:choose>
</xsl:template>



<xsl:template name="drawOK" >
<xsl:param name="name" select="''"/>
<xsl:param name="onClick">void(1);</xsl:param>
<xsl:param name="conHelp" select="''"/>
<xsl:param name="caption">UNKNOWN</xsl:param>
<xsl:param name="ButtonIcon"><xsl:value-of select="$baseURL"/>/images/1x1.gif</xsl:param>
		<div class="commonButton">
			<xsl:attribute name="id"><xsl:value-of select="$id"/></xsl:attribute>
			<xsl:attribute name="title"><xsl:value-of select="$caption"/></xsl:attribute>
			<xsl:attribute name="onclick"><xsl:value-of select="$onClick"/></xsl:attribute>
			<xsl:attribute name="onmouseover">
				mouse_move(&#039;<xsl:value-of select="$conHelp"/>&#039;)
			</xsl:attribute>
 			<xsl:attribute name="onmouseout">mouse_move()</xsl:attribute>
			<button>
				<xsl:attribute name="name"><xsl:value-of select="$name"/></xsl:attribute>
				<xsl:value-of select="$caption"/>
			</button>
			<span><xsl:value-of select="$caption"/></span>
		</div>
<!-- 
<table border="0" cellpadding="0" cellspacing="0" style="cursor :  hand;" width="91px">
 <xsl:attribute name="onclick"><xsl:value-of select="$onClick"/></xsl:attribute>
 <xsl:attribute name="onmouseover">mouse_move(&#039;<xsl:value-of select="$conHelp"/>&#039;)</xsl:attribute>
 <xsl:attribute name="onmouseout">mouse_move()</xsl:attribute>
 <tr>
  <td><img src="{$baseURL}/images/vempty.gif" height="21" width="1"/></td>
  <td  width="91px" nowrap="nowrap" >
	<xsl:attribute name="style">background-image: url('<xsl:value-of select="$ButtonIcon"/>'); border: 0 solid white; background-repeat: no-repeat; text-align:left;</xsl:attribute>
	<div class="commonButton" >
	<xsl:attribute name="title">	
		<xsl:value-of select="$caption"/>
	</xsl:attribute>
	<button style="width: 100%; height: 100%; padding-left: 22px; text-align: left; cursor: hand; background-image: none;">
	<xsl:value-of select="$caption"/>
	</button>
	</div>
  </td>
 </tr>
 </table>
 -->
</xsl:template>

<xsl:template match="NON-SUPPORT">
<table border="0" cellpadding="5" cellspacing="0" width="100%">
 <tr>
  <td width="99%">
   <span class="SB_Style_{@TYPE}MessageTitle"><xsl:value-of select="."/></span>
  </td>
 </tr>
</table>
</xsl:template>
<!--
///
-->
<xsl:template match="ENTITYLIST">
<form name="{@NAME}" method="post" action="{$baseURL}{$baseURL_SUFFIX}{@ACTION}">
<xsl:if test="@ONSUBMIT">
	<xsl:attribute name="onSubmit"><xsl:value-of select="@ONSUBMIT"/></xsl:attribute>
</xsl:if>
<br/>
<script type="text/javascript" language="javascript">
<xsl:comment><xsl:text>
</xsl:text><xsl:apply-templates select="LOCALE" mode="entitylist"/><xsl:text>
</xsl:text>//</xsl:comment><xsl:text>
</xsl:text></script>
<xsl:if test="WARNING">
 <table  align="center" class="SB_Style_WARNING_BOX" cellpadding="0" cellspacing="0" width="100%">
 <tr>
  <td width="25%">&#160;</td>
  <td width="45%" align="center">
   <table align="center" border="0" cellpadding="7" cellspacing="0" width="100%">
   <tr>
    <td align="left" width="1%"><img src="{$baseURL}/images/icon_stop.gif"/></td>
    <td align="left" width="99%"><xsl:apply-templates select="WARNING" mode="form"/></td>
   </tr>
   </table>
  </td>
  <td width="30%">&#160;</td>
 </tr>
 </table>
</xsl:if>
<table class="SB_ENTITYLIST" width="100%" border="0" cellspacing="0" cellpadding="0">
<xsl:if test="WARNING">
 <tr><td><img src="{$baseURL}/images/empty.gif" width="1" height="10" border="0"/></td></tr>
</xsl:if>
<xsl:apply-templates select="TOP-PANEL" mode="entitylist"/>
<tr><td><img src="{$baseURL}/images/empty.gif" width="1" height="10" border="0"/></td></tr>
<tr>
 <td align="left">
  <table width="100%" cellspacing="0" class="list" >
   <xsl:apply-templates select="HEAD"/>
   <xsl:apply-templates select="ENTITY"/>
  </table>
 </td>
</tr>
<tr><td><img src="{$baseURL}/images/empty.gif" width="1" height="10px" border="0"/></td></tr>
</table>
<xsl:if test="REMARK">
<table  width="100%" border="0" cellspacing="0" cellpadding="0">
<tr><td><img src="{$baseURL}/images/empty.gif" width="1" height="5" border="0"/></td></tr>
<tr><td class="SB_Style_REMARK"><xsl:value-of select="REMARK"/></td></tr>
<tr><td><img src="{$baseURL}/images/empty.gif" width="1" height="10" border="0"/></td></tr>
</table>
</xsl:if>

<xsl:apply-templates select="BOTTOM-PANEL" mode="entitylist"/>
<xsl:apply-templates select="HIDDEN"/>
   <xsl:if test="BUTTON">
  	<br/>
	<div class="formArea">
		<table width="100%" class="buttons" cellspacing="0" cellpadding="0"><tr>
		<td class="main" width="0"></td>
		<td class="misc" width="0">
		<xsl:apply-templates select="BUTTON" mode="form-align-right"/>
		</td>
		</tr>
		</table>
	</div>
	</xsl:if>
</form>
</xsl:template>
<!--
////
-->
<xsl:template match="TOP-PANEL" mode="entitylist">
 <tr><td>
  <table class="SB_Style_formcell"  width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <xsl:choose>
    <xsl:when test="SEARCH-FIELD">
     <td width="1%" nowrap="nowrap" class="SB_Style_formtitle" >
       <xsl:value-of select="SEARCH-FIELD/@CAPTION"/><img src="{$baseURL}/images/empty.gif" width="10" height="1" border="0"/>
     </td>
     <td width="1%" class="SB_Style_formfield">
      <input type="text" class="SB_Style_formfield" name="{SEARCH-FIELD/@NAME}" SIZE="" value="{SEARCH-FIELD/@VALUE}">
      <xsl:call-template name="setTabIndex"/>
      </input>
     </td>
     <td width="1%">
      <xsl:apply-templates select="SEARCH-BUTTON" mode="entitylist"/>
     </td>
    </xsl:when>
    <xsl:otherwise>
      <td width="1%">&#160;</td>
      <td width="1%">&#160;</td>
      <td width="1%">&#160;</td>
    </xsl:otherwise>
    </xsl:choose>
    <td width="{96 - count(BUTTON)}%">&#160;</td>
    <td width="1%"><img src="{$baseURL}/images/empty.gif" width="10" height="1" border="0"/></td>
    <xsl:apply-templates select="BUTTON" mode="entitylist"/>
   </tr>
  </table></td></tr>
 </xsl:template>
 <!--
 /////
 -->
 <xsl:template match="BOTTOM-PANEL" mode="entitylist">
 <xsl:if test="count(*)">
  <table cellspacing="0" cellpadding="0" border="0" width="100%">
  <tr><td colspan="{count(BUTTON) + 1}"><img src="{$baseURL}/images/empty.gif" width="1" height="10px" border="0"/></td></tr>
  <tr>
   <xsl:apply-templates select="BUTTON" mode="entitylist-right"/>
   <td width="{99 - count(BUTTON)}%">&#160;</td>
   <td align="right" width="1%">
    <xsl:apply-templates select="PAGE-STRIP"/>
   </td>
  </tr>
  </table>
 </xsl:if>
 <BR/><BR/>
 <xsl:apply-templates select="TABS"/>
 </xsl:template>
 <!--
 /////
 -->
 <xsl:template match="ENTITY">
 <tr>
  <xsl:choose>
  <xsl:when test="@CLASS">
   <xsl:choose>
    <xsl:when test="position() mod 2"><xsl:attribute name="class"><xsl:value-of select="@CLASS"/>evenrowbg</xsl:attribute></xsl:when>
    <xsl:otherwise><xsl:attribute name="class"><xsl:value-of select="@CLASS"/>oddrowbg</xsl:attribute></xsl:otherwise>
   </xsl:choose>
  </xsl:when>
  <xsl:otherwise>
   <xsl:variable name="classSuffix">
    <xsl:choose>
     <xsl:when test="@ENABLED='true'"></xsl:when>
     <xsl:otherwise>_notLicensed</xsl:otherwise>
    </xsl:choose>
   </xsl:variable>
   <xsl:choose>
    <xsl:when test="position() mod 2"><xsl:attribute name="class">evenrowbg</xsl:attribute></xsl:when>
    <xsl:otherwise><xsl:attribute name="class">oddrowbg</xsl:attribute></xsl:otherwise>
   </xsl:choose>
  </xsl:otherwise>  
  </xsl:choose>
  <xsl:apply-templates select="ENTITY-ITEM"/>
 </tr>
 </xsl:template>
 <!--
 //////
 -->
 <xsl:template match="ENTITY-ITEM">
   <xsl:choose>
    <xsl:when test='CHECK'>
	  <td width="1%" style="text-align: center;">
		 <xsl:call-template name="Entity-Item-Entry"/>
      </td>
    </xsl:when>
    <xsl:when test='BUTTON'>
    <xsl:apply-templates select="BUTTON" mode="entitylist-right"/>
    </xsl:when>
    <xsl:otherwise>
	  <td>
		 <xsl:call-template name="Entity-Item-Entry"/>
      </td>
    </xsl:otherwise>
   </xsl:choose>

 </xsl:template>


<xsl:template name="Entity-Item-Entry">
   <xsl:choose>
    <xsl:when test="@ALIGN">
     <xsl:attribute name="align"><xsl:value-of select="@ALIGN"/></xsl:attribute>
    </xsl:when>
<!--    <xsl:otherwise>
     <xsl:attribute name="align">left</xsl:attribute>
    </xsl:otherwise>-->
   </xsl:choose>
<!--   <xsl:choose>
    <xsl:when test="@STYLE">
     <xsl:attribute name="style"><xsl:value-of select="@STYLE"/></xsl:attribute>
    </xsl:when>
    <xsl:otherwise>
     
    </xsl:otherwise>
   </xsl:choose>-->
   <xsl:if test="@CAPTION">
    <xsl:choose>
              <xsl:when test="@CAPTION='A'">
     	<img src="images/btn_show_bg.gif" border="0" style="vertical-align: middle;">
	<xsl:attribute name="title">
		<xsl:value-of select="@CAPTION"/>
	</xsl:attribute></img>&#160;
	<xsl:value-of select="@CAPTION"/>
     </xsl:when>
          
	 <xsl:when test="@CAPTION='D'">
     	<img src="images/btn_hide_bg.gif" border="0" style="vertical-align: middle;">
	<xsl:attribute name="title">
		<xsl:value-of select="@CAPTION"/>
	</xsl:attribute></img>&#160;
	<xsl:value-of select="@CAPTION"/>
     </xsl:when>
	<xsl:when test="ACTION!=''">
      <a>
<!--       <xsl:choose>
        <xsl:when test="parent::node()[@ENABLED='true']">
         <xsl:attribute name="class">SB_Style_formtitle</xsl:attribute>
        </xsl:when>
        <xsl:otherwise>
         <xsl:attribute name="class">SB_Style_formtitle_notLicensed</xsl:attribute>
        </xsl:otherwise>
       </xsl:choose>-->
       <xsl:attribute name="href"><xsl:if test="not(contains(ACTION,'javascript'))"><xsl:value-of select="$baseURL"/><xsl:value-of select="$baseURL_SUFFIX"/></xsl:if><xsl:value-of select="ACTION"/></xsl:attribute>
       <xsl:attribute name="onClick">dc();</xsl:attribute>
       <xsl:value-of select="@CAPTION"/>
      </a>
     </xsl:when>
     <xsl:when test="ONCLICK">
      <a href="javascript:void(1);">
       <xsl:attribute name="class">SB_Style_formtitle</xsl:attribute>
       <xsl:attribute name="onclick"><xsl:value-of select="ONCLICK"/></xsl:attribute>
       <xsl:value-of select="@CAPTION"/>
      </a>
     </xsl:when>
     <xsl:otherwise>
      <span>
<!--        <xsl:choose>
        <xsl:when test="parent::node()[@ENABLED='true']">
         <xsl:attribute name="class">SB_Style_formtitle</xsl:attribute>
        </xsl:when>
        <xsl:otherwise>
         <xsl:attribute name="class">SB_Style_formtitle_notLicensed</xsl:attribute>
        </xsl:otherwise>
       </xsl:choose>-->
       <xsl:value-of select="@CAPTION"/>
      </span>      
     </xsl:otherwise>
    </xsl:choose>
   </xsl:if>
   <xsl:apply-templates mode="entity-item"/>

</xsl:template>

 <!--
 /////
 -->
 <xsl:template match="HEAD">
  <xsl:if test="count(HEAD-ITEM) > 0">
  <tr>
   <xsl:apply-templates select="HEAD-ITEM"/>
  </tr>
  </xsl:if>
 </xsl:template>
 <!--
 /////
 -->


 <xsl:template match="HEAD-ITEM">

   <xsl:choose>
    <xsl:when test='CHECK'>
	  <th width="1%" nowrap="nowrap" style="text-align: center;">
		 <xsl:call-template name="Head-Item-Entry"/>
      </th>
    </xsl:when>
    <xsl:otherwise>
	  <th width="{@WIDTH}%" nowrap="nowrap">
	    <xsl:if test="@ALIGN">
	    <xsl:attribute name="align"><xsl:value-of select="@ALIGN"/></xsl:attribute>
	    <xsl:attribute name="style">text-align: <xsl:value-of select="@ALIGN"/></xsl:attribute>
    	</xsl:if>
	
		<xsl:call-template name="Head-Item-Entry"/>
      </th>
    </xsl:otherwise>
   </xsl:choose>

 </xsl:template>


 <xsl:template name="Head-Item-Entry">
 <xsl:choose>
    <xsl:when test="@SORTBY='true'">
     <xsl:attribute name="class">sort</xsl:attribute>
    </xsl:when>
    <xsl:otherwise>
     <!-- no op -->
    </xsl:otherwise>
   </xsl:choose>

   <xsl:choose>
    <xsl:when test="@ALIGN">
     <xsl:attribute name="align"><xsl:value-of select="@ALIGN"/></xsl:attribute>
    </xsl:when>
    <xsl:otherwise>
     <xsl:attribute name="align">left</xsl:attribute>
    </xsl:otherwise>
   </xsl:choose>
   <xsl:choose>
    <xsl:when test="@STYLE">
     <xsl:attribute name="style"><xsl:value-of select="@STYLE"/></xsl:attribute>
    </xsl:when>
    <xsl:otherwise>
     <!-- no op -->
    </xsl:otherwise>
   </xsl:choose>
   <xsl:if test="@CAPTION">
    <xsl:choose>
     <xsl:when test="ACTION">
      <a class="SB_Style_formtitle" title="{@SORTED-TEXT}">
       <xsl:attribute name="href"><xsl:value-of select="$baseURL"/><xsl:value-of select="$baseURL_SUFFIX"/><xsl:value-of select="ACTION"/></xsl:attribute>
		<xsl:attribute name="onClick">dc();</xsl:attribute>		
       <b><xsl:value-of select="@CAPTION"/></b>
       <xsl:call-template name="head-item.sort.icon"/>
      </a>
     </xsl:when>
     <xsl:otherwise>
      <b><xsl:value-of select="@CAPTION"/></b>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:if>
   <xsl:apply-templates mode="head-item"/>
 </xsl:template>
 <!--
 /////
    <xsl:when test="@STYLE and @SORTBY='true'">
     <xsl:attribute name="style"><xsl:value-of select="sort"/></xsl:attribute>
    </xsl:when>

 -->

 <xsl:template name="head-item.sort.icon">
 <xsl:if test="@SORTBY='true'"><img align="texttop" width="10px" height="16px"  vspace="3" hspace="5" border="0" alt="{@SORTED-TEXT}" title="{@SORTED-TEXT}">
 <xsl:choose>
 <xsl:when test="@DIR='asc'">
  <xsl:attribute name="src"><xsl:value-of select="$skin"/>/icons/arrow_up.gif</xsl:attribute>
 </xsl:when>
 <xsl:otherwise>
  <xsl:attribute name="src"><xsl:value-of select="$skin"/>/icons/arrow_down.gif</xsl:attribute>
 </xsl:otherwise>
 </xsl:choose>
 </img></xsl:if></xsl:template>
 <!--
 /////
 -->
 <xsl:template match="*" mode="head-item">
  <!-- no op -->
 </xsl:template>
 <xsl:template match="*" mode="entity-item">
  <!-- no op -->
 </xsl:template>
 <!--
 /////
 -->
 <xsl:template match="CHECK" mode="head-item">
  <input type="checkbox" class="select" name="{@NAME}" value="{@VALUE}">
   <xsl:call-template name="setTabIndex"/>
   <xsl:if test="@DISABLED='TRUE'">
    <xsl:attribute name="disabled">disabled</xsl:attribute>
   </xsl:if>
   <xsl:if test="@CHECKED='TRUE'">
    <xsl:attribute name="checked">checked</xsl:attribute>
   </xsl:if>
   <xsl:if test="@ONCLICK">
    <xsl:attribute name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:attribute>
   </xsl:if>
  </input>
 </xsl:template>
 <!--
 /////
 -->
 <xsl:template match="CHECK" mode="entity-item">
  <input type="checkbox" class="SB_Style_checkbox" name="{@NAME}" value="{@VALUE}">
   <xsl:call-template name="setTabIndex"/>
   <xsl:if test="@DISABLED='true'">
    <xsl:attribute name="disabled">disabled</xsl:attribute>
   </xsl:if>
   <xsl:if test="@CHECKED='TRUE'">
    <xsl:attribute name="checked">checked</xsl:attribute>
   </xsl:if>
   <xsl:if test="@ONCLICK">
    <xsl:attribute name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:attribute>
   </xsl:if>
  </input>
 </xsl:template>
 <!--
 //////
 -->
 <xsl:template match="INDICATOR" mode="entity-item">
  <xsl:if test="@CAPTION and string-length(@CAPTION) > 0">
   <label title="{@CAPTION}">
    <xsl:value-of select="@CAPTION"/>:</label>
  </xsl:if>
  <div title="{@TITLE}">

   <div title="{@TITLE}" style="background-image: url({$baseURL}/images/icons/{@BG});" class="{@STYLE}">
    <xsl:if test="not(@DETAIL) or string-length(@DETAIL) = 0">&#160;</xsl:if>
    <xsl:value-of select="@DETAIL"/>
   </div>
  </div>
 </xsl:template>
 <!--
 /////
 -->
 <xsl:template match="BUTTON">
   <xsl:call-template name="drawButton">
   <xsl:with-param name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:with-param>
   <xsl:with-param name="caption"><xsl:value-of select="@CAPTION"/></xsl:with-param>
   <xsl:with-param name="ButtonIcon"><xsl:value-of select="$baseURL"/>/images/<xsl:value-of select="@ICON"/></xsl:with-param>
   </xsl:call-template>
 </xsl:template>
 <!--
 /////
 -->
 <xsl:template match="SEARCH-BUTTON" mode="entitylist">
	<xsl:call-template name="drawButton">
		<xsl:with-param name="ButtonIcon"><xsl:value-of select="$baseURL"/>/images/btn_search_bg.gif</xsl:with-param>
		<xsl:with-param name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:with-param>
		<xsl:with-param name="caption"><xsl:value-of select="@CAPTION"/></xsl:with-param>
	</xsl:call-template>

 </xsl:template>
 <xsl:template match="BUTTON" mode="entitylist">
  <td nowrap="nowrap" >
	<xsl:choose>
		<xsl:when test="@NAME='admin_show'"> 
			<xsl:call-template name="drawButton">	
			    <xsl:with-param name="ButtonIcon"><xsl:value-of select="$baseURL"/>/images/btn_show-all_bg.gif</xsl:with-param>
			    <xsl:with-param name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:with-param>
			    <xsl:with-param name="caption"><xsl:value-of select="@CAPTION"/></xsl:with-param>
			</xsl:call-template>
		</xsl:when> 	
		<xsl:when test="@NAME='add' or @NAME='add_range' or @NAME='addtrial'"> 
			<xsl:call-template name="drawButton">	
			    <xsl:with-param name="ButtonIcon"><xsl:value-of select="$baseURL"/>/images/btn_add.gif</xsl:with-param>
			    <xsl:with-param name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:with-param>
			    <xsl:with-param name="caption"><xsl:value-of select="@CAPTION"/></xsl:with-param>
			</xsl:call-template>
		</xsl:when> 	
		<xsl:when test="@CAPTION='Delete'"> 
			<xsl:call-template name="drawButton">	
			    <xsl:with-param name="ButtonIcon"><xsl:value-of select="$baseURL"/>/images/btn_remove-selected_bg.gif</xsl:with-param>
			    <xsl:with-param name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:with-param>
			    <xsl:with-param name="caption"><xsl:value-of select="@CAPTION"/></xsl:with-param>
			</xsl:call-template>
		</xsl:when> 	
		<xsl:otherwise>          
			<xsl:call-template name="drawButton">	
			    <xsl:with-param name="ButtonIcon"><xsl:value-of select="$baseURL"/>/images/1x1.gif</xsl:with-param>
			    <xsl:with-param name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:with-param>
			    <xsl:with-param name="caption"><xsl:value-of select="@CAPTION"/></xsl:with-param>
			</xsl:call-template>
		</xsl:otherwise>
	</xsl:choose>
 </td>
 </xsl:template>
 <!--
 /////
 -->
 <xsl:template match="BUTTON|SEARCH-BUTTON" mode="entitylist-right">
  <td nowrap="nowrap" class="SB_Style_EntitylistRightButton">
	<xsl:choose>
		<xsl:when test="@NAME='bt_delete'"> 
			<xsl:call-template name="drawButton">	
			    <xsl:with-param name="ButtonIcon"><xsl:value-of select="$baseURL"/>/images/btn_remove-selected_bg.gif</xsl:with-param>
			    <xsl:with-param name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:with-param>
			    <xsl:with-param name="caption"><xsl:value-of select="@CAPTION"/></xsl:with-param>
			</xsl:call-template>
		</xsl:when> 	
		<xsl:when test="@NAME='bt_retrieve'"> 
			<xsl:call-template name="drawButton">	
			    <xsl:with-param name="ButtonIcon"><xsl:value-of select="$baseURL"/>/images/btn_refresh-list_bg.gif</xsl:with-param>
			    <xsl:with-param name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:with-param>
			    <xsl:with-param name="caption"><xsl:value-of select="@CAPTION"/></xsl:with-param>
			</xsl:call-template>
		</xsl:when> 	
 		<xsl:when test="@NAME='bt_allow_access' or @NAME='bt_activate'"> 
			<xsl:call-template name="drawButton">	
			    <xsl:with-param name="ButtonIcon"><xsl:value-of select="$baseURL"/>/images/btn_show_bg.gif</xsl:with-param>
			    <xsl:with-param name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:with-param>
			    <xsl:with-param name="caption"><xsl:value-of select="@CAPTION"/></xsl:with-param>
			    <xsl:with-param name="conHelp"><xsl:value-of select="@CON_HELP"/></xsl:with-param>
			</xsl:call-template>
		</xsl:when> 	

		<xsl:when test="@NAME='bt_deny_access' or @NAME='bt_deactivate'"> 
			<xsl:call-template name="drawButton">	
			    <xsl:with-param name="ButtonIcon"><xsl:value-of select="$baseURL"/>/images/btn_hide_bg.gif</xsl:with-param>
			    <xsl:with-param name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:with-param>
			    <xsl:with-param name="caption"><xsl:value-of select="@CAPTION"/></xsl:with-param>
			    <xsl:with-param name="conHelp"><xsl:value-of select="@CON_HELP"/></xsl:with-param>
			</xsl:call-template>
		</xsl:when> 	
		
		<xsl:when test="@CAPTION='A'"> 
			<xsl:call-template name="drawButton">	
			    <xsl:with-param name="ButtonIcon"><xsl:value-of select="$baseURL"/>/images/btn_show_bg.gif</xsl:with-param>
			    <xsl:with-param name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:with-param>
			    <xsl:with-param name="caption"><xsl:value-of select="@CAPTION"/></xsl:with-param>
			    <xsl:with-param name="conHelp">sbm_allowAccess_domain</xsl:with-param>
			</xsl:call-template>
		</xsl:when> 	
		
		<xsl:when test="@CAPTION='D'"> 
			<xsl:call-template name="drawButton">	
			    <xsl:with-param name="ButtonIcon"><xsl:value-of select="$baseURL"/>/images/btn_hide_bg.gif</xsl:with-param>
			    <xsl:with-param name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:with-param>
			    <xsl:with-param name="caption"><xsl:value-of select="@CAPTION"/></xsl:with-param>
			    <xsl:with-param name="conHelp">sbm_denyAccess_domain</xsl:with-param>
			</xsl:call-template>
		</xsl:when> 	
		<xsl:otherwise>          
			<xsl:call-template name="drawButton">	
			    <xsl:with-param name="ButtonIcon"><xsl:value-of select="$baseURL"/>/images/1x1.gif</xsl:with-param>
			    <xsl:with-param name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:with-param>
			    <xsl:with-param name="caption"><xsl:value-of select="@CAPTION"/></xsl:with-param>
			</xsl:call-template>
		</xsl:otherwise>

	</xsl:choose>
	</td>
 </xsl:template>
 <!--
 /////
 -->
 <xsl:template match="BUTTON" mode="form">
	<td nowrap="nowrap" class="SB_Style_FormButton">
<xsl:call-template name="drawButton"> 
    <xsl:with-param name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:with-param>
    <xsl:with-param name="caption"><xsl:value-of select="@CAPTION"/></xsl:with-param>
    <xsl:with-param name="id"><xsl:value-of select="@ID"/></xsl:with-param>
   </xsl:call-template>
</td>
</xsl:template>
 <!--
 /////
 -->
 <xsl:template match="BUTTON" mode="form-align-right">
	<xsl:choose>
		<xsl:when test="@name='bname_cancel'"> 
			<xsl:call-template name="drawOK" >	
				<xsl:with-param name="id"><xsl:value-of select="@ID"/></xsl:with-param>    
				<xsl:with-param name="name"><xsl:value-of select="@name"/></xsl:with-param>
				<xsl:with-param name="ButtonIcon"><xsl:value-of select="$baseURL"/>/images/btn_cancel_bg.gif</xsl:with-param>
			    <xsl:with-param name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:with-param>
			    <xsl:with-param name="caption"><xsl:value-of select="@CAPTION"/></xsl:with-param>
			    <xsl:with-param name="conHelp"><xsl:value-of select="@CON_HELP"/></xsl:with-param>
			</xsl:call-template>
		</xsl:when> 	
		<xsl:when test="@name='bname_ok'"> 
			<xsl:call-template name="drawOK" >	
			    <xsl:with-param name="ButtonIcon"><xsl:value-of select="$baseURL"/>/images/btn_ok_bg.gif</xsl:with-param>
			    <xsl:with-param name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:with-param>
			    <xsl:with-param name="id"><xsl:value-of select="@ID"/></xsl:with-param>
			    <xsl:with-param name="name"><xsl:value-of select="@name"/></xsl:with-param>
			    <xsl:with-param name="caption"><xsl:value-of select="@CAPTION"/></xsl:with-param>
			    <xsl:with-param name="conHelp"><xsl:value-of select="@CON_HELP"/></xsl:with-param>
			</xsl:call-template>
		</xsl:when> 	
		<xsl:otherwise>
			<td nowrap="nowrap" align="right">
			<xsl:call-template name="drawButton">
				<xsl:with-param name="id"><xsl:value-of select="@ID"/></xsl:with-param>
				<xsl:with-param name="name"><xsl:value-of select="@name"/></xsl:with-param>
				<xsl:with-param name="onClick"><xsl:value-of select="@ONCLICK"/></xsl:with-param>
				<xsl:with-param name="caption"><xsl:value-of select="@CAPTION"/></xsl:with-param>
				<xsl:with-param name="conHelp"><xsl:value-of select="@CON_HELP"/></xsl:with-param>
			</xsl:call-template>
			</td>
		</xsl:otherwise>
	</xsl:choose>

 </xsl:template>
 
 
 <!--
 /////
 -->
 <xsl:template match="HIDDEN">
  <input type="hidden" id="{@ID}" name="{@NAME}" value="{@VALUE}"/>
 </xsl:template>
 <!--
 /////
 -->
 <xsl:template match="WARNING" mode="form">
  <xsl:value-of select="."/>
  <xsl:if test="position() != last()"><br/></xsl:if>
 </xsl:template>
 <!--
 /////
 -->
 <xsl:template match="MESSAGE" mode="CRITICAL-ERROR">
  <xsl:value-of select="."/>
  <xsl:if test="position() != last()"><br/></xsl:if>
 </xsl:template>
 <!-- 
 /////
 -->
 <xsl:template match="CRITICAL-ERROR">
  <table align="center" cellpadding="10" cellspacing="10" width="100%">
  <tr>
  <td><table width="70%" align="center" cellspacing="10" cellpadding="10" border='0'>
   <tr>
   <td align="center"><table border='0' cellspacing="10" cellpadding="0" class="SB_Style_WARNING_BOX">
   <tr>
    <td width="70px" align="center" valign="top"><img border="0" src="{$baseURL}/images/demo_publish.gif"/></td>
    <td width="282px" valign="top">
    <table width="282px" cellspacing="0" cellpadding="0" border='0'>
    <tr>
    <td height="44px" width="16px" class="SB_Style_design_text">&#160;</td>
    <td height="44px" width="250px" class="SB_Style_design_text">
     <xsl:if test="TITLE"><h4><xsl:value-of select="TITLE"/></h4></xsl:if>
     <xsl:apply-templates select="MESSAGE" mode="CRITICAL-ERROR"/>
    </td>
    <td height="44px" width="16px" class="SB_Style_design_text">&#160;</td>
    </tr></table></td>
   </tr></table></td>
   </tr></table>
  </td></tr></table>
 </xsl:template>
 <!--
 /////
 -->
 <xsl:template match="FTPHOST-FORM|REGISTRATION-FORM|ADD-SKIN-FORM|ADD-LANG-FORM|FORM">
  <xsl:variable name="cellsTotal"><xsl:choose><xsl:when test="count(//*[@REQUIRED='1'])">3</xsl:when><xsl:otherwise>2</xsl:otherwise></xsl:choose></xsl:variable>
  <form name="{@NAME}" method="post">
   <xsl:attribute name="action"><xsl:value-of select="$baseURL"/><xsl:value-of select="$baseURL_SUFFIX"/><xsl:value-of select="@ACTION"/></xsl:attribute>
   <xsl:if test="@ENCTYPE"><xsl:attribute name="enctype">multipart/form-data</xsl:attribute></xsl:if>
   <xsl:if test="@ONSUBMIT"><xsl:attribute name="onsubmit"><xsl:value-of select="@ONSUBMIT"/></xsl:attribute></xsl:if>
   <xsl:apply-templates select="HIDDEN"/>
   <xsl:apply-templates select="SCRIPT"/>
<br/>
   <xsl:if test="WARNING">
    <table  align="center" class="SB_Style_WARNING_BOX" cellpadding="0" cellspacing="0" width="100%" >
     <tr>
<!--      <td width="25%">&#160;</td> -->
     <td width="45%" align="center">
     <table align="center" border="0" cellpadding="7" cellspacing="0" width="100%">
     <tr>
      <td align="left" width="1%"><img src="{$baseURL}/images/icon_stop.gif"/></td>
      <td align="left" width="99%"><xsl:apply-templates select="WARNING" mode="form"/></td>
     </tr>
     </table>
     </td>
     <td width="30%">&#160;</td>
    </tr>
    </table>
   </xsl:if>
   <table class="SB_DIALOG_FORM" width="100%" border="0" cellspacing="0" cellpadding="0">
   <!-- ////////////////////////////////// -->
   <xsl:if test="TITLE">
   <tr>
    <td colspan="{$cellsTotal}" class="SB_Style_formfieldcolorfirst">
    <table cellspacing="0" cellpadding="5px" border="0" width="100%">
    <tr>
     <td align="center" style="padding-left:10px;" width="20%" class="SB_Style_formtitle"><b><xsl:value-of select="TITLE"/></b>
    </td>
    </tr>
    </table>
    </td>
   </tr>
   </xsl:if>
   <!-- ////////////////////////////////// -->
   <xsl:apply-templates select="FIELD[not(@TYPE) or @TYPE!='hidden']" mode="form">
    <xsl:with-param name="cellsTotal" select="$cellsTotal"/>
   </xsl:apply-templates>
   <tr>
    <td colspan="{$cellsTotal}"><img border="0" src='{$baseURL}/images/empty.gif' width='1' height='10'/></td>
   </tr>
   </table>
   <xsl:apply-templates select="TABS"/>
   <xsl:if test="BUTTON">
  	<br/>
	<div class="formArea">
		<table width="100%" class="buttons" cellspacing="0" cellpadding="0"><tr>
		<xsl:if test="@REQUIRED='1'">
		<td class="main" width="0"><img src="{$baseURL}/images/empty.gif" width="7" height="19" border="0" align="absmiddle"></img><span class="required"> * </span> - Required field</td>
		</xsl:if>
		<td class="misc" width="0">
		<xsl:apply-templates select="BUTTON" mode="form-align-right"/>
		</td>
		</tr>
		</table>
	</div>

  </xsl:if> 
  </form>
 </xsl:template>
 <!--
 /////
 -->
 <xsl:template match="TABS">
	<div id="screenTabs">
		<div id="tabs">
			<ul>
				<xsl:apply-templates select="TAB"/>
			</ul>
		</div>
	</div>
	<BR/>
</xsl:template>

<xsl:template match="TAB">
			<li>
			<xsl:if test="@ACTIVE='yes'">
				<xsl:attribute name="id">current</xsl:attribute>
			</xsl:if>
			<xsl:if test="@CLASS">
				<xsl:attribute name="class"><xsl:value-of select="@CLASS"/></xsl:attribute>
			</xsl:if>			
			<a>
				<xsl:attribute name="onClick">document.<xsl:value-of select="../@FORM"/>.action += '&amp;to_subtab=<xsl:value-of select="@NAME"/>'; document.<xsl:value-of select="../@FORM"/>.submit();</xsl:attribute>
				
			<span><xsl:value-of select="."/></span>
			</a>
			</li>
</xsl:template>

<!--
 -->

 <xsl:template match="FIELD" mode="form">
  <xsl:param name="cellsTotal" select="'2'"/>
  <tr valign="middle">
   <xsl:choose>
    <xsl:when test="position() mod 2">
     <xsl:attribute name="class">SB_Style_formfieldcolor</xsl:attribute>
    </xsl:when>
    <xsl:otherwise>
     <xsl:attribute name="class">SB_Style_formfieldnocolor</xsl:attribute>
    </xsl:otherwise>
   </xsl:choose>
   <xsl:if test="$cellsTotal = 3">
    <td nowrap="nowrap" align="center" width="1%">
    <img src="{$baseURL}/images/empty.gif" width="1" height="19" border="0" align="absmiddle"></img>
    </td>
   </xsl:if>
   <td nowrap="nowrap" class="SB_Style_formtitlePaddingLeft" align="left">
    <xsl:choose>
     <xsl:when test="$cellsTotal = 3">
      <xsl:attribute name="width">49%</xsl:attribute>
     </xsl:when>
     <xsl:otherwise>
      <xsl:attribute name="width">50%</xsl:attribute>
     </xsl:otherwise>
    </xsl:choose>
    <xsl:value-of select="@TITLE"/>
    <xsl:choose>
     <xsl:when test="@REQUIRED='1'"><span class="required">&#160;*&#160;</span></xsl:when>
     <xsl:otherwise><span class="SB_Style_AlertText">&#160;</span></xsl:otherwise>
    </xsl:choose>
	<img src="{$baseURL}/images/empty.gif" width="7" height="19" border="0" align="absmiddle"></img>
   </td>
   <td class="SB_Style_formfield" align="left" width="49%" style="padding-right:10px;">
   <xsl:choose>
   <xsl:when test="@TYPE[.='textdata']">
    <xsl:call-template name="TEXTDATA"/>
   </xsl:when>
   <xsl:when test="@TYPE[.='list']">
    <xsl:call-template name="COMBOBOX"/>
   </xsl:when>
   <xsl:when test="@TYPE[.='pswd']">
    <xsl:call-template name="PSWDBOX"/>
   </xsl:when>
   <xsl:when test="@TYPE[.='area']">
    <xsl:call-template name="TEXTAREA"/>
   </xsl:when>
   <xsl:when test="@TYPE[.='check']">
    <xsl:call-template name="CHECKBOX"/>
   </xsl:when>
   <xsl:when test="@TYPE[.='hidden']">
    <xsl:call-template name="HIDDEN"/>
   </xsl:when>
   <xsl:when test="@TYPE[.='file']">
    <xsl:call-template name="FILE"/>
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="TEXTBOX"/>
   </xsl:otherwise>
   </xsl:choose>
   </td>
  </tr>
 </xsl:template>
 <!--
 ////
 -->
 <xsl:template match="FTPHOST-FORM/WARNING|REGISTRATION-FORM/WARNING|FORM/WARNING">
  <tr>
   <td width="100%" align="center" colspan="4">
    <font size="2" class="SB_Style_searchr_warning">
     <b>
      <xsl:value-of select="."/>
     </b>
    </font>
   </td>
  </tr>
 </xsl:template>
 <!--
 ////
 -->
 <xsl:template match="FTP-LOGIN">
  <xsl:if test="WARNING">
   <table  class="SB_Style_login_LOGIN" cellpadding="0" cellspacing="0" width="400" >
    <tr><td align="center">
    <table border="0" cellpadding="5" cellspacing="0" width="100%">
    <tr>
     <td align="left" width="1%"><img src="{$baseURL}/images/icon_stop.gif"/></td>
     <td align="left" width="99%">
     <xsl:for-each select="WARNING">
      <xsl:value-of select="."/><br/>
     </xsl:for-each>
    </td>
    </tr>
    </table>
    </td></tr>
   </table>
   <br/>
  </xsl:if>

  <xsl:variable name="login" select="FIELD[@NAME='sb_username']"/>
  <xsl:variable name="ftphost" select="FIELD[@NAME='sb_ftp_host']"/>
  <xsl:variable name="passwd" select="FIELD[@NAME='sb_password']"/>
  <xsl:variable name="siteIdentity" select="FIELD[@NAME='sb_site_identity']"/>

  <form name="login" method="post" onSubmit="javascript:return login_oC(this);">
  <xsl:attribute name="action"><xsl:value-of select="$baseURL"/><xsl:value-of select="$baseURL_SUFFIX"/><xsl:value-of select="@ACTION"/></xsl:attribute>
  <fieldset class="SB_Style_fieldset_set">
  <table cellpadding="5" cellspacing="0" width="400" valign="top" border="0" align="center" class="SB_Style_pageform">
  <xsl:if test="$login and $ftphost">
   <tr valign="bottom">
    <td  align="right"><xsl:value-of select="$login/@TITLE"/>:&#160;</td>
    <td nowrap="nowrap" class="SB_Style_formfield"><input
     name="{$login/@NAME}"
     size="{$login/@SIZE}"
     value="{$login/@VALUE}"
     type="text" id="login_name" 
     maxlength="255"
     style="width:106px;" onKeyPress="doVerify(event)">
     <xsl:call-template name="setTabIndex"/>
    </input>&#160;<xsl:value-of select="$ftphost/@TITLE"/>&#160;
    <input
     name="{$ftphost/@NAME}"
     size="{$ftphost/@SIZE}"
     value="{$ftphost/@VALUE}"
     type="text" id="ftp_host" 
     maxlength="255"
     style="width:106px;" onKeyPress="doVerify(event)">
     <xsl:call-template name="setTabIndex"/>
    </input>
<!--
    <xsl:call-template name="COMBOBOX">
     <xsl:with-param name="node" select="$ftphost"/>
     <xsl:with-param name="tabIndex" select="'2'"/>
    </xsl:call-template>
-->
    </td>
   </tr>
  </xsl:if>
  <xsl:if test="$passwd">
   <tr>
    <td class="SB_Style_fieldname" align="right"><xsl:value-of select="$passwd/@TITLE"/>:&#160;</td>
    <td class="SB_Style_formfield" width="10"><input
     name="{$passwd/@NAME}"
     size="{$passwd/@SIZE}"
     value="{$passwd/@VALUE}"
     type="password" id="passwd" maxlength="128" 
     style="width: 106px;"
     onKeyPress="doVerify(event)">
     <xsl:call-template name="setTabIndex"/>
    </input>
    </td>
   </tr>
  </xsl:if>
  <xsl:if test="$siteIdentity">
   <tr>
    <td class="SB_Style_fieldname" align="right"><xsl:value-of select="$siteIdentity/@TITLE"/>:&#160;</td>
    <td class="SB_Style_formfield" width="10">
    <input type="text" id="site_identity" maxlength="255" 
     style="width: 106px;"
     name="{$siteIdentity/@NAME}"
     size="{$siteIdentity/@SIZE}"
     value="{$siteIdentity/@VALUE}"
     onKeyPress="doVerify(event)">
     <xsl:call-template name="setTabIndex"/>
    </input>
    </td>
   </tr>
  </xsl:if>
  </table>
  </fieldset>
  <table border="0" cellpadding="5" cellspacing="0" width="410px">
  <tr>
   <td width="90%">&#160;</td>
   <xsl:apply-templates select="BUTTON" mode="form"/>
  </tr>
  </table>

  <xsl:if test="HELP-TOOLTIP">
   <br/>
   <table  width="410px" align="center" valign="top" border='0' cellspacing="0" cellpadding="0">
   <tr><td class="SB_Style_FtpLogin_HelpTooltip"><xsl:value-of select="HELP-TOOLTIP" disable-output-escaping="yes"/></td></tr>
   </table>
  </xsl:if>

  <script type="text/javascript" language="javascript">
  <xsl:comment>
   document.forms[0].login_name.focus();
  //</xsl:comment>
  </script>
  <input type="hidden" name="sb_ftp_host_name" id="sb_ftp_host_name" value=""/>
  <input type="hidden" name="cmd" id="cmd" value="login"/>
  </form>
 </xsl:template>




 <!--
 ////
 -->
 <xsl:template match="LOGIN">
  <xsl:if test="WARNING">
   <table  class="SB_Style_login_LOGIN" cellpadding="0" cellspacing="0" width="210px">
    <tr><td align="center">
    <table border="0" cellpadding="5" cellspacing="0" width="100%">
    <tr>
     <td align="left" width="1%"><img src="{$baseURL}/images/icon_stop.gif"/></td>
     <td align="left" width="99%">
     <xsl:for-each select="WARNING">
      <xsl:value-of select="."/><br/>
     </xsl:for-each>
    </td>
    </tr>
    </table>
    </td></tr>
   </table>
   <br/>
  </xsl:if>

  <xsl:variable name="login" select="FIELD[@NAME='sb_username']"/>
  <xsl:variable name="passwd" select="FIELD[@NAME='sb_password']"/>
  <xsl:variable name="siteIdentity" select="FIELD[@NAME='sb_site_identity']"/>

  <form name="login" method="post" onSubmit="javascript:return login_oC(this);">
  <xsl:attribute name="action"><xsl:value-of select="$baseURL"/><xsl:value-of select="$baseURL_SUFFIX"/><xsl:value-of select="@ACTION"/></xsl:attribute>
  <fieldset class="SB_Style_fieldset_set">
  <table cellpadding="5" cellspacing="0" width="210px" valign="top" border="0" align="center" class="SB_Style_pageform">
  <xsl:if test="$login">
   <tr valign="bottom">
    <td  align="right" nowrap="nowrap"><xsl:value-of select="$login/@TITLE"/>:&#160;</td>
    <td nowrap="nowrap" class="SB_Style_formfield"><input
     name="{$login/@NAME}"
     size="{$login/@SIZE}"
     value="{$login/@VALUE}"
     type="text" id="login_name"
     maxlength="255"
     style="width:106px;" onKeyPress="doVerify(event)">
     <xsl:call-template name="setTabIndex"/>
    </input></td>
   </tr>
  </xsl:if>
  <xsl:if test="$passwd">
   <tr>
    <td class="SB_Style_fieldname"  nowrap="nowrap" align="right"><xsl:value-of select="$passwd/@TITLE"/>:&#160;</td>
    <td class="SB_Style_formfield" width="10"><input
     name="{$passwd/@NAME}"
     size="{$passwd/@SIZE}"
     value="{$passwd/@VALUE}"
     type="password" id="passwd" 
     maxlength="128" 
     style="width: 106px;"
     onKeyPress="doVerify(event)">
     <xsl:call-template name="setTabIndex"/>
    </input>
    </td>
   </tr>
  </xsl:if>
  <xsl:if test="$siteIdentity">
   <tr>
    <td class="SB_Style_fieldname"  nowrap="nowrap" align="right"><xsl:value-of select="$siteIdentity/@TITLE"/>:&#160;</td>
    <td class="SB_Style_formfield" width="10">
    <input type="text" id="site_identity" maxlength="255" 
     style="width: 106px;"
     name="{$siteIdentity/@NAME}"
     size="{$siteIdentity/@SIZE}"
     value="{$siteIdentity/@VALUE}"
     onKeyPress="doVerify(event)">
     <xsl:call-template name="setTabIndex"/>
    </input>
    </td>
   </tr>
  </xsl:if>
  </table>
  </fieldset>
  <table border="0" cellpadding="5" cellspacing="0" width="215px">
  <tr>
   <td width="90%">&#160;</td>
   <xsl:apply-templates select="BUTTON" mode="form"/>
  </tr>
  </table>

  <xsl:if test="HELP-TOOLTIP">
   <br/>
   <table  width="215px" align="center" valign="top" border='0' cellspacing="0" cellpadding="0">
   <tr><td class="SB_Style_FtpLogin_HelpTooltip"><xsl:value-of select="HELP-TOOLTIP" disable-output-escaping="yes"/></td></tr>
   </table>
  </xsl:if>

  <script type="text/javascript" language="javascript">
  <xsl:comment>
   document.forms[0].login_name.focus();
  //</xsl:comment>
  </script>
  <input type="hidden" name="sb_ftp_host_name" id="sb_ftp_host_name" value=""/>
  <input type="hidden" name="cmd" id="cmd" value="login"/>
  </form>
 </xsl:template>

 <!--
 ///////
 -->
 <xsl:template match="MENU" mode="common">
  <table id="designMenuPanel" cellpadding="0" cellspacing="0" border="0" width="131">
   <tr height="3" width="131">
    <td>
     <img src="{$baseURL}/images/design_menu_top.gif" width="131" height="3"/>
    </td>
   </tr>
   <xsl:apply-templates select="MENU-ITEM" mode="common"/>
   <tr height="3" width="131">
    <td>
     <img src="{$baseURL}/images/design_menu_bot.gif" width="131" height="3"/>
    </td>
   </tr>
  </table>
  <br/>
  <xsl:if test="HELP-MESSAGE">
   <table id="designMenuPanel" cellpadding="0" cellspacing="0" border="0" width="131" class="SB_Style_pcBG">
    <tr height="3" width="131">
     <td>
      <img src="{$baseURL}/images/design_menu_top.gif" width="131" height="3"/>
     </td>
    </tr>
    <tr>
     <td style="background-image: url({$baseURL}/images/design_menu_mid.gif);" class="SB_Style_design_menu">
      <table width="100%" cellspacing="5">
       <tr>
        <td style="background-image: url({$baseURL}/images/design_menu_mid.gif);" class="SB_Style_design_menu">
         <xsl:value-of select="HELP-MESSAGE"/>
        </td>
       </tr>
      </table>
     </td>
    </tr>
    <tr height="3" width="131">
     <td>
      <img src="{$baseURL}/images/design_menu_bot.gif" width="131" height="3"/>
     </td>
    </tr>
   </table>
  </xsl:if>
 </xsl:template>
 <!--
///////
-->
 <xsl:template match="MENU-ITEM" mode="common">
  <tr>
   <td style="background-image: url({$baseURL}/images/design_menu_mid.gif);" class="SB_Style_design_menu" align="middle">
    <xsl:choose>
     <xsl:when test="ACTION">
      <xsl:variable name="ctlAction">
       <xsl:apply-templates select="ACTION"/>
      </xsl:variable>
      <xsl:choose>
       <xsl:when test="$browser='MOZILLA'">
	   
        <xsl:attribute name="onclick">navigation('','<xsl:value-of select="$ctlAction" disable-output-escaping="yes"/>');</xsl:attribute>
        <table width="121" height="23" cellspacing="0" cellpadding="0" align="middle" border="0" style="cursor: hand;">
          <tr>
           <td>
            <img border="0" src="{$baseURL}/images/design_menu_button_l.gif" width="10" height="23"/>
           </td>
           <td style="background-image: url({$baseURL}/images/design_menu_button_m.gif);">
            <xsl:choose>
             <xsl:when test="@SELECTED='1'">
              <xsl:attribute name="class">SB_Style_design_bt_sel</xsl:attribute>
             </xsl:when>
             <xsl:otherwise>
              <xsl:attribute name="class">SB_Style_design_bt</xsl:attribute>
             </xsl:otherwise>
            </xsl:choose>
			<a href="javascript:void(1)" style="text-decoration: none" >
			<xsl:choose>
             <xsl:when test="@SELECTED='1'">
              <xsl:attribute name="class">SB_Style_design_bt_sel</xsl:attribute>
             </xsl:when>
             <xsl:otherwise>
              <xsl:attribute name="class">SB_Style_design_bt</xsl:attribute>
             </xsl:otherwise>
            </xsl:choose>
            <div style="width: 100%;"><xsl:value-of select="@CAPTION"/></div></a>
           </td>
           <td>
            <img border="0" src="{$baseURL}/images/design_menu_button_r.gif" width="14" height="23"/>
           </td>
          </tr>
         </table>
        
       </xsl:when>
       <xsl:when test="$browser='OPERA'">
        <a style="text-decoration: none">
         <xsl:attribute name="href">javascript:navigation('','<xsl:value-of select="$ctlAction" disable-output-escaping="yes"/>');</xsl:attribute>
         <table width="121" height="23" cellspacing="0" cellpadding="0" align="middle" border="0">
          <tr>
           <td>
            <img border="0" src="{$baseURL}/images/design_menu_button_l.gif" width="10" height="23"/>
           </td>
           <td style="background-image: url({$baseURL}/images/design_menu_button_m.gif);">
            <xsl:choose>
             <xsl:when test="@SELECTED='1'">
              <xsl:attribute name="class">SB_Style_design_bt_sel</xsl:attribute>
             </xsl:when>
             <xsl:otherwise>
              <xsl:attribute name="class">SB_Style_design_bt</xsl:attribute>
             </xsl:otherwise>
            </xsl:choose>
            <xsl:value-of select="@CAPTION"/>
           </td>
           <td>
            <img border="0" src="{$baseURL}/images/design_menu_button_r.gif" width="14" height="23"/>
           </td>
          </tr>
         </table>
        </a>
       </xsl:when>
       <xsl:otherwise>
        <table width="121" height="23" cellspacing="0" cellpadding="0" align="middle" border="0">
         <xsl:attribute name="onclick">navigation('','<xsl:value-of select="$ctlAction" disable-output-escaping="yes"/>');</xsl:attribute>
         <tr>
          <td>
           <img border="0" src="{$baseURL}/images/design_menu_button_l.gif" width="10" height="23"/>
          </td>
          <td style="background-image: url({$baseURL}/images/design_menu_button_m.gif);">
           <xsl:choose>
            <xsl:when test="@SELECTED='1'">
             <xsl:attribute name="class">SB_Style_design_bt_sel</xsl:attribute>
            </xsl:when>
            <xsl:otherwise>
             <xsl:attribute name="class">SB_Style_design_bt</xsl:attribute>
            </xsl:otherwise>
           </xsl:choose>
           <xsl:value-of select="@CAPTION"/>
          </td>
          <td>
           <img border="0" src="{$baseURL}/images/design_menu_button_r.gif" width="14" height="23"/>
          </td>
         </tr>
        </table>
       </xsl:otherwise>
      </xsl:choose>
     </xsl:when>
     <xsl:otherwise>
      <table width="121" height="23" cellspacing="0" cellpadding="0" align="middle" border="0">
       <tr>
        <td>
         <img border="0" src="{$baseURL}/images/design_menu_button_l.gif" width="10" height="23"/>
        </td>
        <td style="background-image: url({$baseURL}/images/design_menu_button_m.gif);" class="SB_Style_design_bt_disab">
         <xsl:value-of select="@CAPTION"/>
        </td>
        <td>
         <img border="0" src="{$baseURL}/images/design_menu_button_r.gif" width="14" height="23"/>
        </td>
       </tr>
      </table>
     </xsl:otherwise>
    </xsl:choose>
   </td>
  </tr>
</xsl:template>
<!--
///////
-->
<xsl:template match="ACTION">
 <xsl:value-of select="$baseURL"/>
 <xsl:value-of select="@BASE"/>?<xsl:apply-templates select="PARAMETER" mode="action"/>
</xsl:template>
<!--
///////
-->
<xsl:template match="PARAMETER" mode="action">
 <xsl:value-of select="@NAME"/>=<xsl:value-of select="@VALUE"/>
 <xsl:if test="position()!=last()">&amp;</xsl:if>
</xsl:template>
<!--
///////
-->
<xsl:template match="LOCALE" mode="entitylist">
<xsl:value-of select="@NAME"/>="<xsl:value-of select='@VALUE'/>";
</xsl:template>
 
</xsl:stylesheet>
