<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:param name="baseURL" select="''"/>
<xsl:param name="baseURL_SUFFIX" select="''"/>
<xsl:output method="html" indent="yes" encoding="utf-8"/>

<xsl:template match="USER-PAGE"><xsl:apply-templates/></xsl:template>

<xsl:template match="ENTITYLIST">
<!-- {@ACTION} -->
<form name="{@NAME}" method="post" action="{$baseURL}{$baseURL_SUFFIX}{@ACTION}">
<xsl:if test="WARNING">
 <table  align="center" class="SB_Style_WARNING_BOX" cellpadding="0" cellspacing="0" width="100%" >
 <tr>
  <td width="25%">&#160;</td>
  <td width="45%" align="center">
   <table align="center" border="0" cellpadding="7" cellspacing="0" width="100%">
   <tr>
    <td align="left" width="1%"><img src="{$baseURL}/skins/images/icon_stop.gif"/></td>
    <td align="left" width="99%"><xsl:apply-templates select="WARNING" mode="form"/></td>
   </tr>
   </table>
  </td>
  <td width="30%">&#160;</td>
 </tr>
 </table>
</xsl:if>
<table class="SB_ENTITYLIST" width="100%" border="0" cellspacing="0" cellpadding="0">
<xsl:if test="WARNING">
 <tr><td><img src="{$baseURL}/skins/images/empty.gif" width="1" height="10" border="0"/></td></tr>
</xsl:if>
<xsl:apply-templates select="TOP-PANEL" mode="entitylist"/>
<tr><td><img src="{$baseURL}/skins/images/empty.gif" width="1" height="10" border="0"/></td></tr>
<tr>
 <td align="left">
  <table width="100%" cellspacing="0" cellpadding="1" border="0">
   <xsl:apply-templates select="HEAD"/>
   <xsl:apply-templates select="ENTITY"/>
  </table>
 </td>
</tr>
<tr><td><img src="{$baseURL}/skins/images/empty.gif" width="1" height="10px" border="0"/></td></tr>
</table>
<xsl:if test="REMARK">
<table  width="100%" border="0" cellspacing="0" cellpadding="0">
<tr><td><img src="{$baseURL}/skins/images/empty.gif" width="1" height="5" border="0"/></td></tr>
<tr><td class="SB_Style_REMARK"><xsl:value-of select="REMARK"/></td></tr>
<tr><td><img src="{$baseURL}/skins/images/empty.gif" width="1" height="10" border="0"/></td></tr>
</table>
</xsl:if>

<xsl:apply-templates select="BOTTOM-PANEL" mode="entitylist"/>
<xsl:apply-templates select="HIDDEN"/>
</form>
</xsl:template>

</xsl:stylesheet>
