<?php
//
class ctlHostForm extends ctlForm 
{
	function ctlHostForm($data)
	{
		$fields = array('HOST_NAME' => array('type' => TEXT, 'caption' => lmsg('__Host_Name'), 'required' => 1), 
						'ACTIVE' => array('type' => CHECKBOX, 'caption' => lmsg('RA_Active'), 'required' => 0), 
/*						'RANGE' => array('type' => TEXT, 'caption' => lmsg('RA_Name'), 'required' => 1), 
						'IP_ADDRESS' => array('type' => TEXT, 'caption' => lmsg('RA_Login'), 'required' => 1), 												
						'OWNER' => array('type' => PASSWORD, 'caption' => lmsg('RA_Password'), 'required' => 1),
*/						
						);

		parent::ctlForm($data, $fields);
	}
}


class ctlRangeForm extends ctlForm
{
	function ctlRangeForm($data)
	{
		$fields = array(
			'sb_ftp_host_fst' => array('caption' => lmsg('RA_Host_IP_-_Beginning_of_Range'), 'type' => TEXT, 'required' => 1),
			'sb_ftp_host_sec' => array('caption' => lmsg('RA_Host_IP_-_End_of_Range'), 'type' => TEXT, 'required' => 1),
			'ACTIVE' => array('caption' => lmsg('RA_Active'), 'type' => CHECKBOX),
		);

		parent::ctlForm($data, $fields);
	}
}


class ctlHostFormResellers extends ctlList
{
	function ctlHostFormResellers($in_list_data)
	{
		$columns = array(
		'inlist' => array('caption' => lmsg('RA_In_list'), 'type' => 'handler', 'handler' => 'inlist'),
	 	'LOGIN' => array('caption' => lmsg('RA_Login'), 'type' => 'link'),
	 	'DOMAIN' => array('caption' => lmsg('RA_Domain')),
		'SITES' => array('caption' => lmsg('RA_Sites')),
	 	);

		$this->setFilterOn('LOGIN');

		$this->setCaption($columns);

		$list = new RA_Resellers();
		$list->getList();

		parent::setData($list->list);
		
		$this->in_list_data = $in_list_data['RESELLER_LIST'];
		parent::ctlList(POST_HANDLER);		
	}
	
	function setCaption($caption)
	{
		parent::setCaption($caption);
	}
	
	function id()
	{
		return $this->get('LOGIN');
	}
	
	function inlist()
	{
		if(array_key_exists($this->id(), (array)$this->in_list_data())) return '+'; else return '-';
	}

	function in_list_data()
	{
		return $this->in_list_data;
	}

	function addSaveButtons()
	{
		$res = 	'<HIDDEN ID="do" NAME="todo"/>';
		$res.='<BUTTON ID="bid-ok" name="bname_ok" CAPTION="'.lmsg('RA__btn_save').'" ONCLICK="document.'.$this->form.'.todo.value = \''.SAVE.'\'; document.'.$this->form.'.submit();"/>';		
		$res.='<BUTTON ID="bid-cancel" name="bname_cancel" CAPTION="'.lmsg('RA__btn_cancel').'" ONCLICK="document.'.$this->form.'.todo.value = \''.CANCEL.'\'; document.'.$this->form.'.submit();"/>';
		return parent::addSaveButtons() . $res;
	}
	
	function addBottomButtons()
	{
		$res .= '<BUTTON CAPTION="'.lmsg('RA_Add_to_list').'" ONCLICK="if(doActivate(true)){dc(1);document.forms[0].com.value=1009;document.forms[0].submit();}"/>';
		$res .= '<BUTTON CAPTION="'.lmsg('RA_Remove_from_list').'" ONCLICK="if(doActivate(true)){dc(1);document.forms[0].com.value=1008;document.forms[0].submit();}"/>';
		return $res;
	}
}

?>